package com.chinacreator.video;

import com.alibaba.fastjson.JSONObject;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.sql.DataSource;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@SpringBootApplication
@MapperScan("com.chinacreator.video.mapper")
@ComponentScan
@EnableCaching
@EnableTransactionManagement
public class VideoActivityApplication implements CommandLineRunner {

	public static void main(String[] args) {
		SpringApplication.run(VideoActivityApplication.class, args);
	}
	@Bean
	public ExecutorService getExecutorTools(){
		ExecutorService executorService = Executors.newFixedThreadPool(60);
		return  executorService;
	}


	@Autowired
	DataSource dataSource;

	@Override
	public void run(String... args) throws Exception {
		System.out.println(dataSource.getClass()+" = " + dataSource);
	}
}
