package com.chinacreator.video.pojo;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSetter;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Create by IntelliJ IDEA.
 * User: EricJin
 * Date: 5/14/2018 5:54 PM
 */
public class OrderBean implements Serializable {
    //流水号，格式为时间戳+序列号：YYYYMMDDHHMMSSxxxx，其中xxxx为序列号，从0001开始，排满9999后重新循环
    @JsonProperty("RECORD_SEQUENCE_ID")
    private String recordSeqId = "";
    //业务平台设备类型
    @JsonProperty("SOURCEDEVICE_TYPE")
    private String sourceDeviceType = "";

    @JsonProperty("SOURCEDEVICE_ID")
    private String sourceDeviceId = "";     //业务平台设备ID

    @JsonProperty("SOURCEDEVICE_NAME")
    private String sourceDeviceName = "";    //业务平台名称

    @JsonProperty("SEQUENCENUMBER")
    private String seqNumber = "";      //订单流水号

    @JsonProperty("ACCESS_TYPE")
    private String accessType = "";         //sp/cp的二次认证方式

    @JsonProperty("TOKEN")
    private String token= "";

    @JsonProperty("ORDERID")
    private String orderId= "";

    @JsonProperty("PAY_MDN")
    private String phone= "";         //订购手机号码

    @JsonProperty("PRICE_DESCRIBE")
    private String price= "";

    @JsonProperty("ORDER_METHOD")
    private String orderMethod= "";

    @JsonProperty("SERVICE_INFO")
    private String serviceInfo= "";

    @JsonProperty("FEEPLAN_MODE")
    private String feeplan= "";        //计费模式

    @JsonProperty("UPDATE_TYPE")
    private String updateType= "";

    @JsonProperty("SUBSRIBE_TYPE")
    private String subscribeType= "";

    @JsonProperty("PUSH_ID")
    private String pushId= "";

    @JsonProperty("SERVICETYPE")
    private String serviceType= "";

    private List<Product> Product = new ArrayList<Product>();

    private List<SpProduct> SpProduct = new ArrayList<SpProduct>();

    @JsonProperty("SP_ID")
    private String spid= "";

    @JsonProperty("SP_NAME")
    private String spName= "";

    @JsonProperty("DEVELOPER_NAME")
    private String developerName= "";

    @JsonProperty("SP_SRVPHONE")
    private String spServPhone= "";

    @JsonProperty("SUBSCRIPTION_TIME")
    private String subscribeTime= "";

    @JsonProperty("RENT_DATE")
    private String rentDate= "";       //扣租开始时间(不同用户免费期不一定一样)     yyyyMMddhhmmss

    @JsonProperty("EFFECTIVE_DATE")
    private String effectiveDate= "";      //生效时间 格式：yyyyMMddhhmmss

    @JsonProperty("EXPIREDATE")
    private String expireDate= "";      //失效时间 格式：yyyyMMddhhmmss

    public String getRecordSeqId() {
        return recordSeqId;
    }

    public void setRecordSeqId(String recordSeqId) {
        this.recordSeqId = recordSeqId;
    }

    public String getSourceDeviceType() {
        return sourceDeviceType;
    }

    public void setSourceDeviceType(String sourceDeviceType) {
        this.sourceDeviceType = sourceDeviceType;
    }

    public String getSourceDeviceId() {
        return sourceDeviceId;
    }

    public void setSourceDeviceId(String sourceDeviceId) {
        this.sourceDeviceId = sourceDeviceId;
    }

    public String getSourceDeviceName() {
        return sourceDeviceName;
    }

    public void setSourceDeviceName(String sourceDeviceName) {
        this.sourceDeviceName = sourceDeviceName;
    }

    public String getSeqNumber() {
        return seqNumber;
    }

    public void setSeqNumber(String seqNumber) {
        this.seqNumber = seqNumber;
    }

    public String getAccessType() {
        return accessType;
    }

    public void setAccessType(String accessType) {
        this.accessType = accessType;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public String getOrderId() {
        return orderId;
    }

    public void setOrderId(String orderId) {
        this.orderId = orderId;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getPrice() {
        return price;
    }

    public void setPrice(String price) {
        this.price = price;
    }

    public String getOrderMethod() {
        return orderMethod;
    }

    public void setOrderMethod(String orderMethod) {
        this.orderMethod = orderMethod;
    }

    public String getServiceInfo() {
        return serviceInfo;
    }

    public void setServiceInfo(String serviceInfo) {
        this.serviceInfo = serviceInfo;
    }

    public String getFeeplan() {
        return feeplan;
    }

    public void setFeeplan(String feeplan) {
        this.feeplan = feeplan;
    }

    public String getUpdateType() {
        return updateType;
    }

    public void setUpdateType(String updateType) {
        this.updateType = updateType;
    }

    public String getSubscribeType() {
        return subscribeType;
    }

    public void setSubscribeType(String subscribeType) {
        this.subscribeType = subscribeType;
    }

    public String getPushId() {
        return pushId;
    }

    public void setPushId(String pushId) {
        this.pushId = pushId;
    }

    public String getServiceType() {
        return serviceType;
    }

    public void setServiceType(String serviceType) {
        this.serviceType = serviceType;
    }

    public List<Product> getProduct() {
        return Product;
    }

    @JsonSetter("PRODUCT_INFO")
    public void setProduct(List<Product> product) {
        Product = product;
    }

    public List<SpProduct> getSpProduct() {
        return SpProduct;
    }

    @JsonSetter("SP_PRODUCT_INFO")
    public void setSpProduct(List<SpProduct> spProduct) {
        SpProduct = spProduct;
    }

    public String getSpid() {
        return spid;
    }

    public void setSpid(String spid) {
        this.spid = spid;
    }

    public String getSpName() {
        return spName;
    }

    public void setSpName(String spName) {
        this.spName = spName;
    }

    public String getDeveloperName() {
        return developerName;
    }

    public void setDeveloperName(String developerName) {
        this.developerName = developerName;
    }

    public String getSpServPhone() {
        return spServPhone;
    }

    public void setSpServPhone(String spServPhone) {
        this.spServPhone = spServPhone;
    }

    public String getSubscribeTime() {
        return subscribeTime;
    }

    public void setSubscribeTime(String subscribeTime) {
        this.subscribeTime = subscribeTime;
    }

    public String getRentDate() {
        return rentDate;
    }

    public void setRentDate(String rentDate) {
        this.rentDate = rentDate;
    }

    public String getEffectiveDate() {
        return effectiveDate;
    }

    public void setEffectiveDate(String effectiveDate) {
        this.effectiveDate = effectiveDate;
    }

    public String getExpireDate() {
        return expireDate;
    }

    public void setExpireDate(String expireDate) {
        this.expireDate = expireDate;
    }
}
