package com.chinacreator.video.service;

import org.apache.commons.lang.math.NumberUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityConfigBean;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ActivityConfigDao;
import com.chinacreator.video.mapper.SysDao;

@Component
public class ActivityConfigService {

	@Autowired
	private ActivityConfigDao activityConfigDao;
	
	@Autowired
	private SysDao sysdao;
	
	public void checkActivity(VipInfo vipInfo) throws BussinessException {
		System.out.println(JSON.toJSONString(vipInfo));
		if(StringUtils.isEmpty(vipInfo.getActivetype())) {
			throw new BussinessException("9083", "Activetype无效");
		}
		if(vipInfo.getActivetype().equals("18")) {
			vipInfo.setCpid("aiqy");
			vipInfo.setSpid("1017");
		}else {
			ActivityConfigBean activityConfigBean = activityConfigDao.getConfig(vipInfo.getActivetype());
			System.out.println(JSON.toJSONString(activityConfigBean));
			if(activityConfigBean == null || !activityConfigBean.getStatus().equals("0") || NumberUtils.toLong(sysdao.getSysTime())>NumberUtils.toLong(activityConfigBean.getEndtime()) || NumberUtils.toLong(sysdao.getSysTime())<NumberUtils.toLong(activityConfigBean.getBegintime())) {
				throw new BussinessException("9083", "该活动无效");
			}
			vipInfo.setCpid(activityConfigBean.getCpid());
			vipInfo.setSpid(activityConfigBean.getSpid());
		}
	}
}
