package com.chinacreator.video.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.CapKbxkQryBean;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.CapKbxkQryDao;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class CapKbxkQryService {
    private static final Logger log = LoggerFactory.getLogger("capkbxk");

    @Autowired
    CapOrderService capOrderService;

    @Autowired
    CapKbxkQryDao capKbxkQryDao;


    public void capKbxkQry(String userid,String cpid,String spid) throws BussinessException{
        String BRAND_CODE = "";
        String REMOVE_TAG = "";
        String ACT_TAG = "";
        String RSP_CODE = "";
        String CUST_STATUS = "";
        String valiVal = "";
        String level = "";
        CapKbxkQryBean capKbxkQryBean = new CapKbxkQryBean();
        String capqrydata = "";
        String xkqrydata = "";
        try {
             capqrydata = capOrderService.capQuery(userid);
            if(capqrydata!=null){
                JSONObject capqryJson = JSON.parseObject(capqrydata);
                BRAND_CODE = capqryJson.getString("BRAND_CODE");
                REMOVE_TAG = capqryJson.getString("REMOVE_TAG");
                ACT_TAG = capqryJson.getString("ACT_TAG");
                RSP_CODE = capqryJson.getString("RSP_CODE");
                CUST_STATUS = capqryJson.getString("CUST_STATUS");

            }

             xkqrydata = capOrderService.kbxkQuery(userid);
            if(xkqrydata!=null){
                JSONObject capqryJson = JSON.parseObject(xkqrydata);
                valiVal = capqryJson.getString("valiVal");
                level = capqryJson.getString("level");
            }
            capKbxkQryBean.setUserid(userid);
            capKbxkQryBean.setActtag(ACT_TAG);
            capKbxkQryBean.setBrandcode(BRAND_CODE);
            capKbxkQryBean.setCuststatus(CUST_STATUS);
            capKbxkQryBean.setRemovetag(REMOVE_TAG);
            capKbxkQryBean.setRspcode(RSP_CODE);
            capKbxkQryBean.setUserlevel(level);
            capKbxkQryBean.setValival(valiVal);
            capKbxkQryBean.setCpid(cpid);
            capKbxkQryBean.setSpid(spid);
            if("0004".equals(RSP_CODE)){
                throw new BussinessException("cap0004", "错误码cap0004");
            }
        } catch (Exception e) {
            if ((e instanceof BussinessException)) {
                String resultcode = ((BussinessException) e).getCode();
                String errrorinfo = ((BussinessException) e).getMessage();
                throw new BussinessException(resultcode,errrorinfo);
            }

        } finally {
            log.info("手机号:"+userid+" Cap查询结果:"+capqrydata+" 卡部信控查询结果:"+xkqrydata);
            try {
                capKbxkQryDao.insertCapKbxkLog(capKbxkQryBean);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }


    }




}
