package com.chinacreator.video.service;

import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.mapper.DictionaryDao;
import com.chinacreator.video.util.URLUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.bean.SPInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.CapBusiConfDao;
import com.chinacreator.video.mapper.SpDao;
import com.chinacreator.video.util.CapUtil;


/**
 * CAP接口服务
 * @author xu.zhou
 * @date 20190905
 */
@Component
public class CapOrderService {

	  private static Logger log = Logger.getLogger(CapOrderService.class);

	  @Autowired
	  private SpDao spDao;

	  @Autowired
	  private CapBusiConfDao capBusiConfDao;

	  @Autowired
	  private DictionaryDao dictionaryDao;

	  @Autowired
	  private JiyueService jiyueService;

	  /**
	   * 订购
	   * @param orderInfo	订购信息
	   * @param accesstype //sp/cp的二次认证方式: 	1：H5认证 2：SDK认证 3：短信认证  4：页面认证
	   * @return
	   * @throws Exception
	   */
	  public String order(OrderInfo orderInfo, String accesstype) throws Exception{
		    SPInfo spInfo = getSPInfo(orderInfo.getSpid());
		    String result = "-1";
		  	String errorinfo = "cap订购失败";

//		  if("0".equals(spInfo.getHaslocal())){ //不调CAP接口 只在本地生成订购关系
//			  result = "0";
//			  return result;
//		  }
		    if(spInfo == null || (StringUtils.isEmpty(spInfo.getVacproductid()) && !"0".equals(spInfo.getHaslocal()))){
		    	throw new BussinessException("7003", "产品配置错误");
		    }

		    if (!"0".equals(spInfo.getHaslocal()) && spInfo.getFeetype() == 1) {
//		    	String resJson = CapUtil.cap(orderInfo.getCpid(),orderInfo.getSpid(),orderInfo.getUserid(), spInfo.getSpcode(), spInfo.getVacproductid(), "0",
//		        		orderInfo.getSeqnumber(), accesstype, spInfo.getPrice(), orderInfo.getToken());
//		    	log.info("调CAP返回结果："+resJson);
//			    if (resJson != null) {
//			    	Map map = (Map)JSON.parse(resJson);
//			    	//Map<?,?> map = JsonUtil.jsonToMap(resJson);
//			    	result = map.get("resultcode") != null ? map.get("resultcode").toString() : "-1";
//					errorinfo = map.get("errorinfo") != null ? map.get("errorinfo").toString() : "cap订购失败";
//			    }
				try {
					orderInfo.setAccesstype(accesstype);
					jiyueService.order(orderInfo);
				}catch (Exception e){
					if (e instanceof BussinessException){
						result = ((BussinessException) e).getCode();
						errorinfo = ((BussinessException) e).getMessage();

					}else {
						e.printStackTrace();
						result = "-1";
						errorinfo = "cap退订失败";
					}
				}
		    }

		   /**
			业务返回编码
			0000 处理成功
			0007 订单同步失败
			0009 参数异常
			0008 非4G用户,鉴权失败
			0001 订购鉴权失败/退订鉴权失败
			0004 话单缓存失败
			0003 查询用户归属省编码失败
			0002 cbss产品订购异常
			0006 cbss产品退订异常
		     */
		    if (!result.equals("0")) {
		    	if(!"cardbus".equals(orderInfo.getOrderchannel())){
					insertPushTw(orderInfo.getUserid(),orderInfo.getCpid(),orderInfo.getSpid());
				}
				if(result.equals("-1")){
					throw new BussinessException(result, "cap订购失败:接口调用失败，服务暂不可用");
				}else{
					errorinfo = handelErrorinfo(result,errorinfo);
					throw new BussinessException(result, "cap订购失败:"+errorinfo);

				}
		    }
		    return result;
	  }

	  /**
	   * 退订
	   * @param orderInfo
	   * @return
	   * @throws Exception
	   */
	  public String cancel(OrderInfo orderInfo) throws Exception{
		    SPInfo spInfo = getSPInfo(orderInfo.getSpid());
		    String result = "-1";
		    String errorinfo = "cap退订失败";
		    if(spInfo == null || (StringUtils.isEmpty(spInfo.getVacproductid()) && !"0".equals(spInfo.getHaslocal()))){
		    	throw new BussinessException("7003", "产品配置错误");
		    }
		    if (!"0".equals(spInfo.getHaslocal()) && spInfo.getFeetype() == 1) {
//		    	String resJson = CapUtil.cap(orderInfo.getCpid(),orderInfo.getSpid(),orderInfo.getUserid(), spInfo.getSpcode(), spInfo.getVacproductid(), "1",
//		        		"", "", "", "");
//		    	log.info("调AP返回结果："+resJson);
//			    if (resJson != null) {
//			    	Map map = (Map)JSON.parse(resJson);
//			    	//Map<?,?> map = JsonUtil.jsonToMap(resJson);
//			    	result = map.get("resultcode") != null ? map.get("resultcode").toString() : "-1";
//					errorinfo = map.get("errorinfo") != null ? map.get("errorinfo").toString() : "cap退订失败";
//			    }

				try {
					jiyueService.cancel(orderInfo);
				}catch (Exception e){
					if (e instanceof BussinessException){
						result = ((BussinessException) e).getCode();
						errorinfo = ((BussinessException) e).getMessage();

					}else {
						e.printStackTrace();
						result = "-1";
						errorinfo = "cap退订失败";
					}
				}
		    }

		    /**
			业务返回编码
			0000 处理成功
			0007 订单同步失败
			0009 参数异常
			0008 非4G用户,鉴权失败
			0001 订购鉴权失败/退订鉴权失败
			0004 话单缓存失败
			0003 查询用户归属省编码失败
			0002 cbss产品订购异常
			0006 cbss产品退订异常
		     */

		    if (!result.equals("0")) {
				if(result.equals("-1")){
					throw new BussinessException(result, "cap退订失败:接口调用失败，服务暂不可用");
				}else{
					errorinfo = handelErrorinfo(result,errorinfo);
					throw new BussinessException(result, "cap退订失败:"+errorinfo);

				}
		    }
		    return result;
	  }

	private String handelErrorinfo(String result,String errorinfo){

		if(result.equals("0001") || result.equals("0002") || result.equals("0006") || result.equals("0007")){
			try {
				JSONObject obj = JSON.parseObject(errorinfo);
				String CAP_MSG = obj.getString("CAP_MSG");
				String OTHER_MSG = obj.getString("OTHER_MSG");
				errorinfo = CAP_MSG +","+ OTHER_MSG;
			}catch (Exception e){
				e.printStackTrace();
			}

			return errorinfo;
		}
		return errorinfo;
	}


	/**
	 * cap综合用户信息查询
	 * @param userid
	 * @return
	 * @throws Exception
	 */
	public String capQuery(String userid) throws Exception {

		if(userid!=null && userid!=""){
			String resJson = CapUtil.capQuery(userid);
			log.info("调cap用户综合查询返回结果："+resJson);
			JSONObject obj = JSON.parseObject(resJson);
			String data = obj.getString("data");
			return data;
		}
		return null;
	}


	/**
	 * 卡部信控查询
	 * @param userid
	 * @return
	 */

	public String kbxkQuery(String userid) throws Exception {

		if(userid!=null && userid!=""){
			String resJson = CapUtil.kbxkQuery(userid);
			log.info("调卡部信控查询返回结果："+resJson);
			JSONObject obj = JSON.parseObject(resJson);
			String data = obj.getString("data");
			return data;
		}
		return null;

	}


	  private SPInfo getSPInfo(String spid) throws Exception {
		    return this.spDao.findById(spid);
		  }

	  public boolean hasCap(OrderInfo orderInfo) throws Exception{
		  String cnt = capBusiConfDao.hasCap(orderInfo.getCpid(), orderInfo.getSpid());
		  if(Integer.parseInt(cnt)>0){
			  return true;
		  }else{
			  return false;
		  }
	  }

	/**
	 * CAP订购失败推送拓维后向订购
	 * @param userid
	 * @param cpid
	 * @param spid
	 */

	public void insertPushTw(String userid,String cpid,String spid){

		try {

			Map<String, String> map = new HashMap<String, String>();
			map.put("userid",userid);
			map.put("kcSpid",spid);
			map.put("kcCpid",cpid);
			map.put("type", "twhx");
			String  mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
			URLUtil.post(mqReciveUrl,JSON.toJSONString(map));
			//测试环境
//			URLUtil.post("http://10.199.99.158:8030/mq-service/recive.do", JSON.toJSONString(map));
			//生产环境
//			URLUtil.post("http://10.199.99.144:8090/mq-service/recive.do", JSON.toJSONString(map));
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
