package com.chinacreator.video.service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.dto.QueryDataOutPipe;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.AreaDao;

@Component
public class ChannelOrderVipService {

	@Autowired
	private ComonService comonService;

	@Autowired
	private ChannelValidate channelValidate;

	@Autowired
	private CpSpService cpSpService;

	@Autowired
	private MobService mobService;

	@Autowired
	private OrderService orderService;

	@Autowired
	private AreaDao areaDao;

	@Autowired
	private VipService vipService;

	public void orderValidate(OrderInfo orderInfo) throws BussinessException {
		if (orderInfo == null) {
			throw new BussinessException("9085", "参数错误");
		}
		comonService.checkTimestamp(orderInfo.getTimestamp());
		channelValidate.validate(orderInfo.getChannel());
		comonService.checkSignChannel(orderInfo);
		cpSpService.checkSp(orderInfo);
		mobService.checkChannelMob(orderInfo);
		if (orderInfo.getType() == 0
				&& (StringUtils.isEmpty(orderInfo.getUsertype()) || StringUtils.isEmpty(orderInfo.getUserval()))) {
			throw new BussinessException("9084", "userval/usertype参数错误");
		}
		Map<String, String> map = areaDao.getArea(orderInfo.getUserid());
		if (map != null) {
			orderInfo.setProvince(map.get("province") == null ? "" : map.get("province"));
			orderInfo.setArea(map.get("area") == null ? "" : map.get("area"));
		}
		
		//省份限制验证
		comonService.valiProvinceLimit(orderInfo);
	}

	public void channelQueryValidate(OrderInfo orderInfo) throws BussinessException {
		if (orderInfo == null) {
			throw new BussinessException("9085", "参数错误");
		}
		comonService.checkTimestamp(orderInfo.getTimestamp());
		channelValidate.validate(orderInfo.getChannel());
		comonService.checkSignChannelQuery(orderInfo);
		cpSpService.checkSp(orderInfo);
		mobService.checkChannelMob(orderInfo);
	}

	public void channelOrder(OrderInfo orderInfo) throws Exception {
		if(orderInfo.getSpid().equals("84")) {
			List<QueryDataOutPipe> querylist = orderService.queryOrder(orderInfo);
			QueryDataOutPipe queryDataOutPipe84 = null;
	 		QueryDataOutPipe queryDataOutPipe101 = null;
			if(querylist != null && querylist.size()>0) {
				for (QueryDataOutPipe queryDataOutPipe : querylist) {
					if(queryDataOutPipe.getCpid().equals("tencent") && queryDataOutPipe.getSpid().equals("84")) {
						queryDataOutPipe84 = queryDataOutPipe;
					}else if(queryDataOutPipe.getCpid().equals("tencent") && queryDataOutPipe.getSpid().equals("101")) {
						queryDataOutPipe101 = queryDataOutPipe;
					}
				}
			}
			if(queryDataOutPipe84 == null && queryDataOutPipe101==null) {
				orderInfo.setSpid("101");
				orderInfo.setActivetype("11");
				orderInfo.setOrdertype(1);
				orderService.order(orderInfo);
			}else if(queryDataOutPipe84 != null && queryDataOutPipe101==null && queryDataOutPipe84.getOrderstatus().equals("1")) {
				orderInfo.setSpid("101");
				orderInfo.setActivetype("11");
				orderInfo.setOrdertype(3);
				orderInfo.setErrorhandle(1);
				orderService.preOrder(orderInfo);
			}else if(queryDataOutPipe84 != null && queryDataOutPipe101!=null && queryDataOutPipe84.getOrderstatus().equals("1") && queryDataOutPipe101.getOrderstatus().equals("3")) {
				orderInfo.setSpid("101");
				orderInfo.setActivetype("11");
				orderInfo.setOrdertype(3);
				orderInfo.setErrorhandle(1);
				orderService.preOrder(orderInfo);
			}else if(queryDataOutPipe101 != null && queryDataOutPipe84 == null && queryDataOutPipe101.getOrderstatus().equals("1")){
				orderInfo.setSpid("101");
				orderInfo.setActivetype("11");
				orderInfo.setOrdertype(1);
				orderService.order(orderInfo);
			}else {
				throw new BussinessException("9060", "用户已订购");
			}
		}else {
			orderService.order(orderInfo);
		}
	}

	public List<QueryDataOutPipe> queryOrder(OrderInfo orderInfo) {
 		List<QueryDataOutPipe> list = new ArrayList<>();
 		QueryDataOutPipe queryDataOutPipe84 = null;
 		QueryDataOutPipe queryDataOutPipe101 = null;
//		List<QueryDataOutPipe> listQueryDataOutPipe = queryOrderDao.getOrder(orderInfo);
//		if (listQueryDataOutPipe != null && listQueryDataOutPipe.size() > 0) {
//			for (QueryDataOutPipe queryDataOutPipe : listQueryDataOutPipe) {
//				if (queryDataOutPipe.getSpid().equals("101")) {
//					queryDataOutPipe.setSpid("84");
//				}
//				list.add(queryDataOutPipe);
//			}
//		}
		List<QueryDataOutPipe> querylist = orderService.queryOrder(orderInfo);
		if(querylist != null && querylist.size() > 0) {
			for (QueryDataOutPipe queryDataOutPipe : querylist) {
				if(queryDataOutPipe.getCpid().equals("tencent") && queryDataOutPipe.getSpid().equals("84")) {
					queryDataOutPipe84 = queryDataOutPipe;
				}else if(queryDataOutPipe.getCpid().equals("tencent") && queryDataOutPipe.getSpid().equals("101")) {
					queryDataOutPipe101 = queryDataOutPipe;
				}
			}
		}
		if(queryDataOutPipe84 != null && queryDataOutPipe101==null) {
			list.add(queryDataOutPipe84);
		}else if(queryDataOutPipe84 == null && queryDataOutPipe101!=null){
			queryDataOutPipe101.setSpid("84");
			list.add(queryDataOutPipe101);
		}else if(queryDataOutPipe84 != null && queryDataOutPipe101!=null) {
			if(queryDataOutPipe84.getOrderstatus().equals("1") && queryDataOutPipe101.getOrderstatus().equals("2")) {
				queryDataOutPipe101.setOrderstatus("0");
				queryDataOutPipe101.setSpid("84");
				list.add(queryDataOutPipe101);
			}else if(queryDataOutPipe84.getOrderstatus().equals("1") && queryDataOutPipe101.getOrderstatus().equals("3")) {
				queryDataOutPipe101.setOrderstatus("1");
				queryDataOutPipe101.setSpid("84");
				list.add(queryDataOutPipe101);
			}else{
				list.add(queryDataOutPipe84);
			}
		}
		return list;
	}

	public void channelVip(OrderInfo orderInfo) throws BussinessException {
		if(orderInfo.getErrorhandle() != 1) {
			VipInfo activityInfo = new VipInfo();
			activityInfo.setUserid(orderInfo.getUserid());
			activityInfo.setCpid(orderInfo.getCpid());
			activityInfo.setSpid(orderInfo.getSpid());
			activityInfo.setActivetype(orderInfo.getActivetype());
			activityInfo.setUserval(orderInfo.getUserval());
			activityInfo.setUsertype(orderInfo.getUsertype());
			vipService.giveVip(activityInfo);
		}
	}

	public void channelCancel(OrderInfo orderInfo) throws Exception {
		if (orderInfo.getSpid().equals("84")) {
//			List<QueryDataOutPipe> listQueryDataOutPipe = queryOrderDao.getOrder(orderInfo);
//			if (listQueryDataOutPipe != null && listQueryDataOutPipe.size() > 0) {
//				for (QueryDataOutPipe queryDataOutPipe : listQueryDataOutPipe) {
//					if (queryDataOutPipe.getSpid().equals("101")) {
//						orderInfo.setSpid("101");
//						orderInfo.setCanceltype(1);
//					}
//				}
//			}
			List<QueryDataOutPipe> querylist = orderService.queryOrder(orderInfo);
			QueryDataOutPipe queryDataOutPipe84 = null;
	 		QueryDataOutPipe queryDataOutPipe101 = null;
			if(querylist != null && querylist.size()>0) {
				for (QueryDataOutPipe queryDataOutPipe : querylist) {
					if(queryDataOutPipe.getCpid().equals("tencent") && queryDataOutPipe.getSpid().equals("84")) {
						queryDataOutPipe84 = queryDataOutPipe;
					}else if(queryDataOutPipe.getCpid().equals("tencent") && queryDataOutPipe.getSpid().equals("101")) {
						queryDataOutPipe101 = queryDataOutPipe;
					}
				}
			}
			if(queryDataOutPipe84 != null && queryDataOutPipe101==null && queryDataOutPipe84.getOrderstatus().equals("0")) {
				orderInfo.setCanceltype(2);
				orderService.cancel(orderInfo);
			}else if(queryDataOutPipe84 == null && queryDataOutPipe101!=null && queryDataOutPipe101.getOrderstatus().equals("0")) {
				orderInfo.setSpid("101");
				orderInfo.setActivetype("11");
				orderInfo.setCanceltype(1);
				orderService.cancel(orderInfo);
			}else if(queryDataOutPipe84 != null && queryDataOutPipe101!=null && queryDataOutPipe101.getOrderstatus().equals("2") && queryDataOutPipe84.getOrderstatus().equals("1")) {
				orderInfo.setSpid("101");
				orderInfo.setActivetype("11");
				orderInfo.setCanceltype(3);
				orderService.preCancel(orderInfo);
			}else if(queryDataOutPipe101 != null && queryDataOutPipe84 != null && queryDataOutPipe101.getOrderstatus().equals("2") && queryDataOutPipe84.getOrderstatus().equals("0")){
				orderInfo.setCanceltype(2);
				orderService.cancel(orderInfo);
				orderInfo.setSpid("101");
				orderInfo.setActivetype("11");
				orderInfo.setCanceltype(3);
				orderService.preCancel(orderInfo);
			}else {
				throw new BussinessException("9064", "用户已退订");
			}
		}else {
			orderService.cancel(orderInfo);
		}
	}
}
