package com.chinacreator.video.service;

import java.text.SimpleDateFormat;
import java.util.*;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.mapper.*;
import com.chinacreator.video.util.CycleUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.ActivityConfigBean;
import com.chinacreator.video.bean.ActivityVipConfigBean;
import com.chinacreator.video.bean.ContinueBean;
import com.chinacreator.video.bean.CpSpBean;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.bean.UserMsgBean;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.bean.VipWhiteBean;
import com.chinacreator.video.bean.WhiteBean;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.OrderLog;
//import com.chinacreator.video.service.handle.Aiqy20GetVipService;
import com.chinacreator.video.service.handle.GetVipService;
import com.chinacreator.video.util.StrUtil;
import com.chinacreator.video.util.URLUtil;
import com.chinacreator.video.util.VacUtil;

@Component
public class ContinueVipService {

    private static final Logger log = LoggerFactory.getLogger("vipservice");

    public static String VIPPOOL_FANKA_VIP_31 = "0";

    @Autowired
    private ActiveDao activeDao;

//	@Autowired
//	private ActivityVipConfigDao activityVipDao;

    @Autowired
    private SysDao sysDao;

    @Autowired
    private UserMsgDao userMsgDao;

    @Autowired
    private EcbService ecbService;

    @Autowired
    private OrderDao orderDao;

    @Autowired
    private OrderLogDao orderLogDao;

    @Autowired
    private CpSpDao cpSpDao;

    @Autowired
    private WhiteDao whiteDao;

    @Autowired
    private GiveVipService giveVipService;

    //	@Autowired
//	private GiveVipFankaService giveVipFankaService;
    @Autowired
    private DictionaryDao dictionaryDao;

    @Autowired
    private OrderService orderService;

    @Autowired
    private VacControlService vacControlService;

    @Autowired
    private CtvGiveVipService ctvGiveVipService;

    @Autowired
    private AiqiyiGiveVipService aiqiyiGiveVipService;

    @Autowired
    private AiqiyiGiveMonthVipService aiqiyiGiveMonthVipService;
//
//	@Autowired
//	private Aiqy20GetVipService aiqy20Service;

    @Autowired
    private LeshiNewGiveVipService leshiNewGiveVipService;

    @Autowired
    private MangtvGiveVipService mangtvGiveVipService;

    @Autowired
    private PptvGiveVipService pptvGiveVipService;

    @Autowired
    private YoukuVipService youkuVipService;

    @Autowired
    private Youku20VipService youku20VipService;

    @Autowired
    private Fushion12VipService fengx12VipService;

//	@Autowired
//	private SohuVipService sohuVipService;

    @Autowired
    private WasuGiveVipService wasuVipService;

    @Autowired
    private VipWhiteDao vipWhiteDao;

    @Autowired
    private UnifiedAuthService unifiedAuthService;

    @Autowired
    private EcbVipService ecbVipService;

//	@Autowired
//	private RedisService redisService;

    @Autowired
    private ActivityVipConfigService vipConfigService;

    @Autowired
    private ActivityConfigDao activityConfigDao;

    @Autowired
    private VipControlMultiService vipControlService;

    @Autowired
    private GetVipService getVipService;

    @Autowired
    private CycleDao cycleDao;

    @Autowired
    private CycleControlService cycleControlService;

    @Autowired
    private ActiveAiqyContinueDao activeAiqyContinueDao;

    @Autowired
    private ContinueDao continueDao;


    public void checkContinueVip(ContinueBean continueBean) throws BussinessException {
        checkUserMsg(continueBean);
        checkBuss(continueBean);
    }

    public void continueGivehandle(ContinueBean continueBean) throws BussinessException {
        ActivityBean activityBean = null;
        //是复合产品
        if (!StringUtils.isEmpty(continueBean.getFhcpid()) && !StringUtils.isEmpty(continueBean.getFhspid())) {
            activityBean = activeDao.getActivityInfoByFh(continueBean.getUserid(), continueBean.getCpid(),
                    continueBean.getSpid(), continueBean.getFhcpid(),
                    continueBean.getFhspid(), continueBean.getActivityType());
        } else {
            activityBean = activeDao.getActivityInfo(continueBean.getUserid(), continueBean.getCpid(),
                    continueBean.getSpid(), continueBean.getActivityType());
        }

        try {
            VipWhiteBean vipWhiteBean = vipWhiteDao.getCount("0", continueBean.getUserid(), continueBean.getCpid(), continueBean.getSpid());
            if (vipWhiteBean != null && vipWhiteBean.getType().equals("1")) {
                throw new BussinessException("9089", "黑名单用户禁止领取");
            }

            //是复合产品
            if (!StringUtils.isEmpty(continueBean.getFhcpid()) && !StringUtils.isEmpty(continueBean.getFhspid())) {
                //会员赠送限制
                ecbVipService.queryEcb(continueBean.getUserid(), continueBean.getFhcpid(), continueBean.getFhspid(), activityBean.getProvince(), 1, continueBean.getActivityType());

            } else {
                //会员赠送限制
                ecbVipService.queryEcb(continueBean.getUserid(), continueBean.getCpid(), continueBean.getSpid(), activityBean.getProvince(), 1, continueBean.getActivityType());

            }

            giveVip(continueBean, activityBean);
            activityBean.setVipconstatus("0");
        } catch (Exception e) {
            if (e instanceof BussinessException) {
                String code = ((BussinessException) e).getCode();
                if ("990099".equals(code)) {
                    String orderid = new SimpleDateFormat("yyyyMM").format(new Date()) + "01" + continueBean.getUserid() + "_" + continueBean.getActivityType() + "_" + continueBean.getSpid();
                    log.info("异步流程=======" + orderid);
                    activityBean.setVipconstatus(code);
                    activityBean.setRequestid(orderid);
                } else {
                    activityBean.setVipconstatus("2");
                }
            } else {
                activityBean.setVipconstatus("2");
            }
            throw e;
        } finally {
            activeDao.updateContimueVip(activityBean);
        }
    }

    public void cancel(ContinueBean continueBean, String channel) throws Exception {
        OrderInfo orderInfo = new OrderInfo();
        orderInfo.setUserid(continueBean.getUserid());
        orderInfo.setCpid(continueBean.getCpid());
        orderInfo.setSpid(continueBean.getSpid());
        orderInfo.setChannel(channel);
        orderInfo.setCanceltype(2);
        orderInfo.setTimes(System.currentTimeMillis() + "");
        orderService.cancel(orderInfo);
    }

    public void giveVip(ContinueBean continueBean, ActivityBean activityBean) throws BussinessException {
        UserMsgBean userMsgBean = userMsgDao.getMsg(continueBean.getUserid(), continueBean.getCpid(),
                continueBean.getSpid(), continueBean.getActivityType());
        VipInfo activityInfo = new VipInfo();
        activityInfo.setActivetype(continueBean.getActivityType());
        activityInfo.setUserid(userMsgBean.getUserid());
        activityInfo.setUsertype(userMsgBean.getMsg2());
        activityInfo.setUserval(userMsgBean.getMsg1());
        activityInfo.setType(1);
        activityInfo.setCpid(continueBean.getCpid());
        activityInfo.setSpid(continueBean.getSpid());
        activityInfo.setVippool(continueBean.getVippool());

        //活动代码
        String activetype = continueBean.getActivityType();
        //CPID
        String cpid = continueBean.getCpid();
        //SPID
        String spid = continueBean.getSpid();

        ActivityVipConfigBean config = vipConfigService.getVipConfigBean(activetype, cpid, spid);
        if (config != null) {
            activityInfo.setVippool(config.getVippoolcontinue());

            //查询续送配置表 20220411 can.he
            String vipid_new = "";
            String vippwd_new = "";

            Map<String, String> map = null;
            //增加acid判断  ,传acid使用 TB_VIP_CONTINUE_CONF 配置的会员池,用于spid:1058,1064 在10月1号后订购的会员续送
            if(!StringUtils.isEmpty(continueBean.getAcid())){
                 map  = continueDao.getVipInfoById(continueBean.getAcid());
                 if(map!=null){
                     System.out.println("ACID not null ,is:" + continueBean.getAcid());
                     vipid_new = map.get("vipid") == null ? "" : map.get("vipid");
                     vippwd_new = map.get("vippwd") == null ? "" : map.get("vippwd");
                     map.clear();//FOR GC
                 }
            }
            //子渠道会员池的优先级高于普通会员池的优先级
            if (continueBean.getOrderchannel2() != null && !continueBean.getOrderchannel2().equals("")) {
                map = continueDao.getVipInfo(cpid, spid, continueBean.getOrderchannel2());
                if (map != null) {
                    System.out.println("续送有子渠道配置================" + continueBean.getOrderchannel2() + "===" + cpid + "===" + spid);
                    vipid_new = map.get("vipid") == null ? "" : map.get("vipid");
                    vippwd_new = map.get("vippwd") == null ? "" : map.get("vippwd");
                    //因为config有缓存，所以下面的代码屏蔽调了
//                    config.setVipidcontinue(map.get("vipid") == null ? "" : map.get("vipid"));
//                    config.setVippwdcontinue(map.get("vippwd") == null ? "" : map.get("vippwd"));
                }
            }


            //腾讯会员
            if ("tencent".equals(cpid)) {
                activityInfo.setUsertype("4");
                activityInfo.setUserval(userMsgBean.getUserid());
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    if ("vip_31".equals(config.getVippoolcontinue())) {
                        giveVipService.give(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

                //爱奇艺会员
            } else if ("aiqy".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if ("1035".equals(spid)) {
                        if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                            getVipService.give(activityInfo, vipid_new, vippwd_new);
                        } else {
                            getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                        }

                    } else {
                        //getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                        //String vipidcontinue = "00030";
                        //String vippwdcontinue = "aiqy2018";
						/*if ("202108".equals(sysDao.getSysTime().substring(0, 6))) {
							if ((activeAiqyContinueDao.getviplogcount(activityInfo.getUserid(), "2021_aiqy_ykcl_31", "202106") > 0) &&
									(activeAiqyContinueDao.getviplogcount(activityInfo.getUserid(), "2021_aiqy_ykcl_31", "202107") > 0)) {
								getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
							} else {
								getVipService.give(activityInfo, vipidcontinue, vippwdcontinue);
							}
						} else {
							//确定需要查询的日期
							Calendar curCal = Calendar.getInstance();
							curCal.add(Calendar.MONTH, -1);
							String lastMonth = new SimpleDateFormat("yyyyMM").format(curCal.getTime());
							if (activeAiqyContinueDao.getviplogcount(activityInfo.getUserid(), "2021_aiqy_ykcl_31", lastMonth) > 0) {

							} else {
								getVipService.give(activityInfo, vipidcontinue, vippwdcontinue);
							}
						}*/
                        if ("20".equals(activetype)) {
//						    if(activeAiqyContinueDao.getConUservalCount(activityInfo.getUserid()) > 0){  //20220223 can.he
//                                getVipService.give(activityInfo, "00073", "aiqy2018");
//                            }
                            //确定需要查询的日期
                            Calendar curCal = Calendar.getInstance();
                            curCal.add(Calendar.MONTH, -1);
                            String lastMonth = new SimpleDateFormat("yyyyMM").format(curCal.getTime());
                            if (activeAiqyContinueDao.getviplogcount(activityInfo.getUserid(), "2021_aiqy_ykcl_31", lastMonth) > 0) { //改为请从3月起，调整爱奇艺前向20元产品使用存量接口续送规则，上月使用存量接口续送的用户，本月仍然使用存量接口续送，其他使用普通月卡接口完成续送。
                                getVipService.give(activityInfo, "00073", "aiqy2018");
                            } else {
                                if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                                    getVipService.give(activityInfo, vipid_new, vippwd_new);
                                } else {
                                    getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                                }
                            }
//                        } else if("83".equals(activetype)){  //20220223 因为83产品已经下线了，所以屏蔽掉  can.he
//                            if(activeAiqyContinueDao.getConUservalCount(activityInfo.getUserid()) > 0){
//                                getVipService.give(activityInfo, "00074", "aiqy2018");
//                            }else {
//                                getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
//                            }
                        } else {
                            if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                                getVipService.give(activityInfo, vipid_new, vippwd_new);
                            } else {
                                getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                            }
                        }
                    }
                } else {
                    if ("aiqy_vip_31".equals(config.getVippoolcontinue())) {
                        aiqiyiGiveVipService.give(activityInfo);
                    } else if ("aiqymonth_vip_31".equals(config.getVippoolcontinue())) {
                        aiqiyiGiveMonthVipService.give(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

                //优酷会员
            } else if ("youtu".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    if ("2019_youku_vip_31".equals(config.getVippoolcontinue())) {
                        youkuVipService.giveVip(activityInfo);
                    } else if ("youku20_vip_31".equals(config.getVippoolcontinue())) {
                        youku20VipService.giveVip(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

                //芒果会员
            } else if ("mangtv16".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }

                } else {
                    if ("mangtv16_vip_31".equals(config.getVippoolcontinue())) {
                        mangtvGiveVipService.give(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

                //PPTV会员
            } else if ("pptv".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }

                } else {
                    if ("pptv_vip_31".equals(config.getVippoolcontinue())) {
                        pptvGiveVipService.giveVip(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

                //CCTV会员
            } else if ("cctv".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    if ("cctv_vip".equals(config.getVippoolcontinue())) {
                        ctvGiveVipService.give(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

                //乐视会员
            } else if ("leshilt".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                } else {
                    if ("letv_continue_vip_31".equals(config.getVippoolcontinue())) {
                        leshiNewGiveVipService.give(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

            } else if ("huashuapp".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    if ("wasu_vip_30".equals(config.getVippoolcontinue())) {
                        wasuVipService.giveVip(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

            } else if ("fengx".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                } else {
                    if ("fushion12_vip_31".equals(config.getVippoolcontinue())) {
                        fengx12VipService.giveVip(activityInfo);
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

            } else if ("sohutv".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    if ("sohu_wovip_31".equals(config.getVippoolcontinue())) {
                        getVipService.give(activityInfo, "00043", "shy72dh3");
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }

            } else if ("xueguoxue".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }

                } else {
                    if ("xgx_vip_31".equals(config.getVippoolcontinue())) {
                        getVipService.give(activityInfo, "00045", "xgx02ml5");
                    } else {
                        throw new BussinessException("9109", "续送会员配置异常");
                    }
                }
            } else if ("bilibl".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    throw new BussinessException("9109", "续送会员配置异常");
                }
            } else if ("ppsport".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    throw new BussinessException("9109", "续送会员配置异常");
                }
            } else if ("kcpptv".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    throw new BussinessException("9109", "续送会员配置异常");
                }

            } else if ("kckeep1".equals(cpid) || "kckeep2".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    getVipService.giveAsyn(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue(),activityBean);
                } else {
                    throw new BussinessException("9109", "续送会员配置异常");
                }

            } else if ("changshi".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
//                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                        if ("1217".equals(spid)) { // keep异步
                            getVipService.giveAsyn(activityInfo, vipid_new, vippwd_new, activityBean);
                        } else {
                            getVipService.give(activityInfo, vipid_new, vippwd_new);
                        }
                    } else {
//                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                        if ("1217".equals(spid)) { // keep异步
                            getVipService.giveAsyn(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue(), activityBean);
                        } else {
                            getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                        }
                    }
                } else {
                    throw new BussinessException("9109", "续送会员配置异常");
                }
            } else if ("yangshipin".equals(cpid)) {
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.give(activityInfo, vipid_new, vippwd_new);
                    } else {
                        getVipService.give(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue());
                    }
                } else {
                    throw new BussinessException("9109", "续送会员配置异常");
                }
            } else if ("keep".equals(cpid)) {  //异步流程
                if (StrUtil.isNotBlank(config.getVipidcontinue(), config.getVippwdcontinue())) {
                    if (!vipid_new.equals("") && !vippwd_new.equals("")) {
                        getVipService.giveAsyn(activityInfo, vipid_new, vippwd_new, activityBean);
                    } else {
                        getVipService.giveAsyn(activityInfo, config.getVipidcontinue(), config.getVippwdcontinue(), activityBean);
                    }
                } else {
                    throw new BussinessException("9109", "续送会员配置异常");
                }
            } else {
                throw new BussinessException("9109", "续送会员配置异常");
            }
        } else {
            throw new BussinessException("9109", "续送会员配置异常");
        }

    }

    public void order(ContinueBean continueBean) throws BussinessException {
        String resultcode = "0";
        String errorinfo = "续订成功";
        String times = System.currentTimeMillis() + "";
        try {
            List<OrderInfo> localOrderInfos = orderDao.getOrderByUserid(continueBean.getUserid());
            if (localOrderInfos == null || localOrderInfos.size() == 0) {
                throw new BussinessException("10017", "订购关系无订购记录");
            }
            CpSpBean cpSpBean = cpSpDao.getCpSp(continueBean.getCpid(), continueBean.getSpid());
            for (OrderInfo localOrderInfo : localOrderInfos) {
                if (localOrderInfo.getCpid().equals(continueBean.getCpid())
                        && localOrderInfo.getSpid().equals(continueBean.getSpid()) && localOrderInfo.getStatus() != 0
                        && NumberUtils.toLong(localOrderInfo.getCanceltime().substring(0, 8)) != NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMdd"))) {
                    throw new BussinessException("10018", "用户已退订");
                }
                String[] mutexs = cpSpBean.getMutex() == null ? null : cpSpBean.getMutex().trim().split(",");
                if (mutexs != null && mutexs.length > 0 && Arrays.asList(mutexs).contains(localOrderInfo.getSpid())) {
                    throw new BussinessException("10019", "用户已订购相同产品或者未失效");
                }
            }
            WhiteBean whiteBean = whiteDao.getUser(continueBean.getUserid(), continueBean.getCpid());
            if (whiteBean != null) {
                if (whiteBean.getType().equals("1")) {
                    try {
                        cancel(continueBean, "blacancel");
                    } catch (Exception e) {
                        throw new BussinessException("9065", "黑名单用户禁止订购,本地退订失败");
                    }
                    throw new BussinessException("9065", "黑名单用户禁止订购");
                }
            }
            if (whiteBean == null || whiteBean.getVac().equals("1")) {
                String result = "";
                OrderInfo orderInfo = new OrderInfo();
                orderInfo.setUserid(continueBean.getUserid());
                orderInfo.setCpid(continueBean.getCpid());
                orderInfo.setSpid(continueBean.getSpid());
                //checkEcb(continueBean);
                String firstOrderid = cycleDao.qryFirstOrderid(continueBean.getUserid(), continueBean.getCpid(), continueBean.getSpid());

                if ("84".equals(continueBean.getSpid()) && firstOrderid != "" && firstOrderid != null) {
                    cycleControlService.canOrder(orderInfo);
                    try {
                        //调cap包周期续订接口
                        String str = CycleUtil.cycleReorder(continueBean.getUserid(), "8000990000", firstOrderid, continueBean.getCpid(), continueBean.getSpid());
                        if (str != null && str != "") {
                            JSONObject obj = JSONObject.parseObject(str);
                            result = obj.getString("resultcode");
                            cycleControlService.saveVacOrder(orderInfo, result);
                            if (!result.equals("0")) {
                                //throw new BussinessException(result, "订购失败，cap包周期续订错误");
                                throw new BussinessException(result, obj.getString("errorinfo") == null ? "订购失败，cap包周期续订错误" : obj.getString("errorinfo"));
                            }
                        }
                    } catch (Exception e) {
                        if ((e instanceof BussinessException)) {
                            resultcode = ((BussinessException) e).getCode();
                            errorinfo = ((BussinessException) e).getMessage();
                            throw new BussinessException(resultcode, errorinfo);
                        } else {
                            throw new BussinessException("10021", "cap包周期续订调用失败");
                        }
                    }


                } else {

                    throw new BussinessException("10022", "续订失败 无orderid");

/*					vacControlService.canOrder(orderInfo);
					//调用续订同步接口  同步订单
					unifiedAuthService.remainUserSycn(orderInfo);
					try {
						result = VacUtil.vac(continueBean.getUserid(), cpSpBean.getSpcode(), cpSpBean.getVacproductid(),
								cpSpBean.getType(), orderInfo.getId() == null ? "" : orderInfo.getId());

						vacControlService.saveVacOrder(orderInfo, result);
						if(!result.equals("0")){
							throw new BussinessException(result, "订购失败，VAC错误");
						}

					} catch (Exception e) {
						if ((e instanceof BussinessException)) {
							resultcode = ((BussinessException) e).getCode();
							errorinfo = ((BussinessException) e).getMessage();
							throw new BussinessException(resultcode,errorinfo);
						}else{
							throw new BussinessException("10020","vac调用失败");
						}
					}*/
                }

//				vacControlService.saveVacOrder(orderInfo, result);
//				if (!result.equals("0")) {
//					//inserSmstMq(continueBean);
////				try {
////					cancel(continueBean, "lvac");
////				} catch (Exception e) {
////					throw new BussinessException(result, "订购失败，VAC错误,本地退订失败");
////				}
//					throw new BussinessException(result, "订购失败，VAC错误");
//				}
            }
        } catch (Exception e) {
            resultcode = "8000";
            errorinfo = "系统忙,请稍后再试";
            if ((e instanceof BussinessException)) {
                resultcode = ((BussinessException) e).getCode();
                errorinfo = ((BussinessException) e).getMessage();
                if (errorinfo.length() > 200) {
                    errorinfo = errorinfo.substring(0, 200);
                }
            }
            throw e;
        } finally {
            savaLog(continueBean, resultcode, errorinfo, times);
        }
    }


    public void checkBuss(ContinueBean continueBean) throws BussinessException {
        ActivityBean activityBean = null;
        //是复合产品
        if (!StringUtils.isEmpty(continueBean.getFhcpid()) && !StringUtils.isEmpty(continueBean.getFhspid())) {
            activityBean = activeDao.getActivityInfoByFh(continueBean.getUserid(), continueBean.getCpid(),
                    continueBean.getSpid(), continueBean.getFhcpid(),
                    continueBean.getFhspid(), continueBean.getActivityType());
        } else {
            activityBean = activeDao.getActivityInfo(continueBean.getUserid(), continueBean.getCpid(),
                    continueBean.getSpid(), continueBean.getActivityType());
        }
        if (activityBean == null) {
            throw new BussinessException("10011", "活动表无记录");
        }

        //多项选择产品，子产品设置为不送会员
        if ("1".equals(activityBean.getVipconflag())) {
            throw new BussinessException("10021", "此子产品设置的不续送会员");

            //多项选择产品，子产品设置为可送会员
        } else if ("0".equals(activityBean.getVipconflag())) {
            try {
                ActivityConfigBean config = activityConfigDao.getConfig(continueBean.getActivityType());
                continueBean.setGivecount(Integer.parseInt(config.getGivecount()));
            } catch (Exception e) {
                continueBean.setGivecount(0);
            }
            //多项选择会员领取并发控制，及领取数量控制
            vipControlService.canGiveVip(continueBean);

            if (!"0".equals(activityBean.getVipstatus()) && !"4".equals(activityBean.getVipstatus())) {
                throw new BussinessException("10013", "用户还未主动领取会员");
            }

            if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getViptime().substring(0, 6))) {
                throw new BussinessException("10013", "用户本月已领取");
            }
        } else {
            if (!"0".equals(activityBean.getVipstatus())) {
                throw new BussinessException("10013", "用户还未主动领取会员");
            }
            if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getViptime().substring(0, 6))) {
                throw new BussinessException("10013", "用户本月已领取");
            }
        }

        if (activityBean.getVipconstatus() != null && activityBean.getVipconstatus().equals("0")
                && (sysDao.getSysTime().substring(0, 6).equals(activityBean.getVipcontime().substring(0, 6)))) {
            throw new BussinessException("10014", "本月已续送会员");
        }
    }

    public void checkUserMsg(ContinueBean continueBean) throws BussinessException {
        UserMsgBean userMsgBean = userMsgDao.getMsg(continueBean.getUserid(), continueBean.getCpid(),
                continueBean.getSpid(), continueBean.getActivityType());
        if (userMsgBean == null) {
            throw new BussinessException("10015", "缺少用户送会员账户信息");
        }
    }

    public void checkEcb(ContinueBean continueBean) throws BussinessException {
        try {
            ecbService.queryEcb(continueBean.getUserid(), continueBean.getCpid(), continueBean.getSpid(), "");
        } catch (BussinessException e) {
            inserSmstMq(continueBean);
            try {
                cancel(continueBean, "ecb");
            } catch (Exception e1) {
                throw new BussinessException("10016", "查询三户失败，本地退订失败");
            }
            throw new BussinessException(e.getCode(), e.getMessage());
        }
    }

    public void inserSmstMq(ContinueBean continueBean) {
        if (continueBean.getCpid().equals("tencent") && continueBean.getSpid().equals("84")) {
            try {
                Map<String, String> map = new HashMap<String, String>();
                map.put("userid", continueBean.getUserid());
                map.put("cpid", continueBean.getCpid());
                map.put("spid", continueBean.getSpid());
                map.put("result", "0");
                map.put("channel", "");
                map.put("style", "13");
                map.put("times", "");
                map.put("orderType", "");
                map.put("type", "cssms");
                String mqReciveUrl = dictionaryDao.getValue("mqReciveUrl");
                URLUtil.post(mqReciveUrl, JSON.toJSONString(map));
//				URLUtil.post("http://10.199.99.158:8030/mq-service/recive.do", JSON.toJSONString(map));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public void savaLog(ContinueBean continueBean, String resultcode, String errorinfo, String times) {
        OrderInfo xuding = new OrderInfo();
        xuding.setUserid(continueBean.getUserid());
        xuding.setCpid(continueBean.getCpid());
        xuding.setSpid(continueBean.getSpid());
        OrderInfo orderInfo = orderDao.getOrder(xuding);
        if (orderInfo != null) {
            OrderLog orderLog = new OrderLog();
            orderLog.setSpid(continueBean.getSpid());
            orderLog.setCpid(continueBean.getCpid());
            orderLog.setUserid(continueBean.getUserid());
            orderLog.setErrorinfo("续订：" + errorinfo);
            orderLog.setErrorcode(resultcode);
            orderLog.setApptype("");
            orderLog.setOrdertype(orderInfo.getOrdertype() + "");
            orderLog.setChannel(orderInfo.getOrderchannel());
            orderLog.setOrderstatus(orderInfo.getOrderstatus());
            orderLog.setStatus(orderInfo.getStatus());
            orderLog.setArea(orderInfo.getArea());
            orderLog.setProvince(orderInfo.getProvince());
            orderLog.setIsexperience(0);
            orderLog.setTimes((System.currentTimeMillis() - NumberUtils.toLong(times)) + "");
            orderLogDao.insertLog(orderLog);
        } else {
            OrderLog orderLog = new OrderLog();
            orderLog.setSpid(continueBean.getSpid());
            orderLog.setCpid(continueBean.getCpid());
            orderLog.setUserid(continueBean.getUserid());
            orderLog.setErrorinfo("续订：" + "订购关系无此产品订购记录");
            orderLog.setErrorcode("10017");
            orderLog.setApptype("");
            orderLog.setOrdertype("");
            orderLog.setChannel("");
            orderLog.setOrderstatus(2);
            orderLog.setStatus(0);
            orderLog.setArea("");
            orderLog.setProvince("");
            orderLog.setIsexperience(0);
            orderLog.setTimes((System.currentTimeMillis() - NumberUtils.toLong(times)) + "");
            orderLogDao.insertLog(orderLog);

        }

    }

}
