package com.chinacreator.video.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import com.chinacreator.video.bean.CpSpBean;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.CpSpDao;

@Component
public class CpSpService {

	@Autowired
	private CpSpDao CpSpDao;
	
	public void checkSp(OrderInfo orderInfo) throws BussinessException {
		if(StringUtils.isEmpty(orderInfo.getCpid())) {
			throw new BussinessException("9057", "cpid不能为空");
		}
		if(StringUtils.isEmpty(orderInfo.getSpid())) {
			throw new BussinessException("9058", "spid不能为空");
		}
		CpSpBean cpspBean = CpSpDao.getCpSp(orderInfo.getCpid(),orderInfo.getSpid());
		if(cpspBean == null || StringUtils.isEmpty(cpspBean.getCpid()) || StringUtils.isEmpty(cpspBean.getSpid())) {
			throw new BussinessException("9059", "cpid/spid参数不正确");
		}
		orderInfo.setMutex(cpspBean.getMutex());
		orderInfo.setMutextype(cpspBean.getMutextype());
	}
	
	public void checkSp(String cpid,String spid) throws BussinessException {
		if(StringUtils.isEmpty(cpid)) {
			throw new BussinessException("9057", "cpid不能为空");
		}
		if(StringUtils.isEmpty(spid)) {
			throw new BussinessException("9058", "spid不能为空");
		}
		CpSpBean cpspBean = CpSpDao.getCpSp(cpid,spid);
		if(cpspBean == null || StringUtils.isEmpty(cpspBean.getCpid()) || StringUtils.isEmpty(cpspBean.getSpid())) {
			throw new BussinessException("9059", "cpid/spid参数不正确");
		}
	}
}
