package com.chinacreator.video.service;

import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.CycleDao;
import com.chinacreator.video.redis.RedisService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class CycleControlService {



    @Autowired
    private RedisService redisService;

    @Autowired
    private CycleDao cycleDao;



    public void canOrder(OrderInfo orderInfo) throws BussinessException {
        try {
            if ((orderInfo.getCpid().equals("tencent")
                    && (orderInfo.getSpid().equals("84") || orderInfo.getSpid().equals("85")
                    || orderInfo.getSpid().equals("86") || orderInfo.getSpid().equals("87")
                    || orderInfo.getSpid().equals("88") || orderInfo.getSpid().equals("89")))
                    || (orderInfo.getCpid().equals("cctv") && orderInfo.getSpid().equals("10081"))) {
                checkRedis(orderInfo);
                checkOrdered(orderInfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            if (e instanceof BussinessException) {
                throw e;
            }
        }
    }


    public void checkRedis(OrderInfo orderInfo) throws BussinessException {
        long count = redisService
                .incr("cap_" + orderInfo.getCpid() + "_" + orderInfo.getSpid() + "_" + orderInfo.getUserid());
        if (count > 1) {
            throw new BussinessException("8001", "并发请求，请稍后再试");
        }
    }


    public void checkOrdered(OrderInfo orderInfo) throws BussinessException {
        String countnum = cycleDao.getOrderInfo(orderInfo.getUserid(), orderInfo.getCpid(), orderInfo.getSpid());
        if (!countnum.equals("0")) {
            throw new BussinessException("8002", "重复cap包周期订购请求，请稍后再试");
        }
    }



    public void saveVacOrder(OrderInfo orderInfo, String result) {
        try {
            if ((orderInfo.getCpid().equals("tencent")
                    && (orderInfo.getSpid().equals("84") || orderInfo.getSpid().equals("85")
                    || orderInfo.getSpid().equals("86") || orderInfo.getSpid().equals("87")
                    || orderInfo.getSpid().equals("88") || orderInfo.getSpid().equals("89")))
                    || (orderInfo.getCpid().equals("cctv") && orderInfo.getSpid().equals("10081"))) {
                if (result.equals("0")) {
                    cycleDao.insertOrderInfo(orderInfo);
                }
                redisService.removeKey(
                        "cap_" + orderInfo.getCpid() + "_" + orderInfo.getSpid() + "_" + orderInfo.getUserid());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }



}
