package com.chinacreator.video.service;

import java.util.Map;
import java.util.TreeMap;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.VipLog;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.VipDao;
import com.chinacreator.video.util.SHAUtil;
import com.chinacreator.video.util.URLUtil;

/**
 * Create by IntelliJ IDEA.
 * Author: EricJin
 * Date: 10/24/2018 2:51 PM
 */
@Service
public class MangtvFreeVipService {
//    private final static String VIPURL = "http://47.94.145.64:8080/orderService/public/ordersync";   //测试
        private final static String VIPURL = "http://mflow.bz.mgtv.com/orderService/public/ordersync";       //prod
    private final static String PWD = "57081d38d55b4c6985dsg98";
    private final static String PRODUCTID = "RN5Zpki8GwVh";        //prod
    private final static String USERTYPE = "phone";
    private final static String ACCESSPARTY = "zglt";
    private final static String OPERATOR = "lt";
    private static final Logger log = LoggerFactory.getLogger("viplog");

    @Autowired
    private SysDao sysDao;
    @Autowired
    private VipDao vipDao;
    @Autowired
    VipControlService vipControlService;

    public void give(VipInfo activityInfo) throws BussinessException {
        log.debug("activityInfo--------" + JSON.toJSONString(activityInfo));
        this.vipControlService.canGiveVip(activityInfo);

        VipLog vipLog = new VipLog();
        vipLog.setResultcode("0");
        vipLog.setErrorinfo("");
        vipLog.setActivityType(activityInfo.getActivetype());
        vipLog.setUserid(activityInfo.getUserid());
        vipLog.setType(activityInfo.getType());
        vipLog.setUsertype(activityInfo.getUsertype());
        vipLog.setUserval(activityInfo.getUserval());
        vipLog.setVipdays("31");
        
        //订单重试
        boolean flagCorp=false;
        String toCorpOrderid=null;
        if(activityInfo.getVippool()!=null && !"".equals(activityInfo.getVippool().trim())){
        	toCorpOrderid =  vipDao.getOrderId2(activityInfo.getUserid(), activityInfo.getActivetype(),activityInfo.getVippool());
        }else{
        	toCorpOrderid =  vipDao.getOrderId(activityInfo.getUserid(), activityInfo.getActivetype());
        }
        if(toCorpOrderid != null && !"".equals(toCorpOrderid)){
        	flagCorp=true;
        }

        try {
            Map<String,String> param = new TreeMap<>();
            
            //重试订单
            String order_id = null;
            if(flagCorp){
            	order_id = toCorpOrderid;
            }else{
            	order_id = this.sysDao.getId();
            }

            String begintime = this.sysDao.getSysTime();
            String endtime = this.sysDao.getLastDay();

            vipLog.setOrderid(order_id);
            vipLog.setBegintime(begintime);
            vipLog.setEndtime(endtime);

            String user  = activityInfo.getUserid();
            param.put("productId",PRODUCTID);
            param.put("orderId",order_id);
            param.put("user",user);
            param.put("buyTime",begintime);
            param.put("userType",USERTYPE);
            param.put("accessParty",ACCESSPARTY);
            param.put("operator",OPERATOR);

            String urlParam = URLUtil.mapToUrl(param);
            log.debug("============签名前查询字符串============");
            log.debug(urlParam);

            //签名MD5加密
            String sign = SHAUtil.shaEncode((urlParam + "&secret_key=" + PWD).toLowerCase()).toLowerCase();

            String url = VIPURL + "?" + urlParam + "&sign=" + sign;

          //发起请求
			String result=null;
			boolean flag9070=false;
            try {
            	log.debug(url);
                vipLog.setOutput(JSON.toJSONString(param));
                result = URLUtil.get(url);
//              result = "{\"msg\":{\"order_code\":\"201810241447001399202338\",\"start_time\":\"2018-10-24 14:47:00\",\"new_user\":\"new\",\"password\":\"443913\",\"end_time\":\"2018-11-24 23:59:59\",\"days\":31,\"vip_id\":1,\"seqid\":\"1a55a7b7-447f-4f61-8d61-c6b27a9ec9fc\",\"status\":\"200\"},\"code\":\"S000\",\"err\":0}";
                vipLog.setReturnput(result);
                log.debug(result);
            } catch (Exception e) {
            	flag9070=true;
            }
            JSONObject obj = JSON.parseObject(result);
            
          //主动重试
			if(flag9070 || result == null || obj==null || obj.get("code")==null){
				log.info(JSON.toJSONString(vipLog));
				try {
					result = URLUtil.get(url);
					vipLog.setReturnput(result);
					obj = JSON.parseObject(result);
				} catch (Exception e) {
					vipLog.setResultcode("9070");
					vipLog.setErrorinfo("赠送会员超时或者异常");
					throw new BussinessException("9070", "赠送会员超时或者异常");
				}
				
				//两次都返回有问题，就给前台返回9070，让用户发起重试
				if(obj==null || obj.get("code")==null){
					vipLog.setResultcode("9070");
					vipLog.setErrorinfo("赠送会员超时或者异常");
					throw new BussinessException("9070", "赠送会员超时或者异常");
				}
			}
			
			//解析返回结果
			String code = obj.getString("code");
			String msg = obj.getString("err");
			if("0".equals(code)){
				code="-0";
			}
			
			//订单是否成功
			boolean flagvip = false;
			if("S000".equals(code) || "S031".equals(code)){
				flagvip=true;
			}
			
			try {
				//把原有的9070订单标记失败
				if(flagCorp && flagvip && vipDao.getCount9070(activityInfo.getUserid(), toCorpOrderid)>0){
					vipDao.updateOrderIdAll(activityInfo.getUserid(), toCorpOrderid, "1","订单重试表明：此订单失败");
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
            
			vipLog.setResultcode(flagvip?"0":code);
			vipLog.setErrorinfo(msg);
			vipControlService.saveVipGive(activityInfo, flagvip?"0":"1");
			if(!flagvip) {
				throw new BussinessException("9071", "赠送会员失败:"+obj.getString("msg"));
			}
        } catch (Exception e) {
            if (e instanceof BussinessException)
                throw (BussinessException) e;
            else
                throw new BussinessException("8000", e.getMessage());
        } finally {
            log.info(JSON.toJSONString(vipLog));
            saveLog(vipLog);
        }
    }

    public void saveLog(VipLog vipLog) {
// 		vipLog.setResultcode("1");
    	
    	if(vipLog.getReturnput()==null){
			vipLog.setReturnput("");
		}
		if(vipLog.getResultcode()==null){
			vipLog.setResultcode("-0");
		}
		if(vipLog.getErrorinfo()==null){
			vipLog.setErrorinfo("");
		}
        this.vipDao.insert(vipLog);
    }

}
