package com.chinacreator.video.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;
import com.chinacreator.video.bean.VipInfo;
import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityMsgBean;
import com.chinacreator.video.bean.AsynOrderBean;
import com.chinacreator.video.bean.CpSpBean;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ChannelDao;
import com.chinacreator.video.mapper.CpSpDao;
import com.chinacreator.video.util.AESUtil;
import com.chinacreator.video.util.DesUtil;
import com.chinacreator.video.util.UsermobUtil;



@Component
public class MobService {

	private static final String MOB_KEY = "ac22273abb2f4960";
	
	@Autowired
	private CpSpDao CpSpDao;
	
	@Autowired
	private ChannelDao channelDao;
	
	public void checkMob(OrderInfo orderInfo) throws BussinessException {
		String userid = orderInfo.getUserid();
		if(StringUtils.isEmpty(userid)) {
			throw new BussinessException("9054", "userid不能为空");
		}
		CpSpBean cpSpBean = CpSpDao.getCpSp(orderInfo.getCpid(),orderInfo.getSpid());
		String mobType = cpSpBean.getMobtype();
		System.out.println(JSON.toJSONString(cpSpBean));
		try {
		if(mobType.equals("0")) {
			userid = DesUtil.decode(userid, cpSpBean.getPwd());
		}else {
			System.out.println("userid="+userid);
			userid = DesUtil.decode(userid, cpSpBean.getPwd());
			if(userid.length() > 11) {
				userid = AESUtil.decrypt(userid, MOB_KEY);
			}
			System.out.println("userid="+userid);
		}
		if(!UsermobUtil.isValid(userid)) {
			throw new BussinessException("9055", "userid不正确");
		}
		}catch(Exception e) {
			e.printStackTrace();
			throw new BussinessException("9056", "userid加密错误");
		}
		orderInfo.setUserid(userid);
	}
	
	public void checkVipMob(VipInfo activityInfo) throws BussinessException {
		String userid = activityInfo.getUserid();
		if(StringUtils.isEmpty(userid)) {
			throw new BussinessException("9054", "userid不能为空");
		}
		CpSpBean cpSpBean = CpSpDao.getCpSp(activityInfo.getCpid(),activityInfo.getSpid());
		String mobType = cpSpBean.getMobtype();
		try {
		if(mobType.equals("0")) {
			userid = DesUtil.decode(userid, cpSpBean.getPwd());
		}else {
			userid = DesUtil.decode(userid, cpSpBean.getPwd());
			if(userid.length() > 11) {
				userid = AESUtil.decrypt(userid, MOB_KEY);
			}
		}
		if(!UsermobUtil.isValid(userid)) {
			throw new BussinessException("9055", "userid不正确");
		}
		}catch(Exception e) {
			throw new BussinessException("9056", "userid加密错误");
		}
		activityInfo.setUserid(userid);
	}
	
	public void checkChannelVipMob(VipInfo activityInfo) throws BussinessException {
		String userid = activityInfo.getUserid();
		if(StringUtils.isEmpty(userid)) {
			throw new BussinessException("9054", "userid不能为空");
		}
		String pwd = channelDao.queryChannel(activityInfo.getChannel()).getPassword();
		try {
			userid = DesUtil.decode(userid,pwd);
		if(!UsermobUtil.isValid(userid)) {
			throw new BussinessException("9055", "userid不正确");
		}
		}catch(Exception e) {
			throw new BussinessException("9056", "userid加密错误");
		}
		activityInfo.setUserid(userid);
	}
	
	public void checkMsgMob(ActivityMsgBean activityMsgBean) throws BussinessException {
		String userid = activityMsgBean.getUserid();
		if(StringUtils.isEmpty(userid)) {
			throw new BussinessException("9054", "userid不能为空");
		}
		CpSpBean cpSpBean = CpSpDao.getCpSp(activityMsgBean.getCpid(),activityMsgBean.getSpid());
		String mobType = cpSpBean.getMobtype();
		try {
		if(mobType.equals("0")) {
			userid = DesUtil.decode(userid, cpSpBean.getPwd());
		}else {
			userid = DesUtil.decode(userid, cpSpBean.getPwd());
			if(userid.length() > 11) {
				userid = AESUtil.decrypt(userid, MOB_KEY);
			}
		}
		if(!UsermobUtil.isValid(userid)) {
			throw new BussinessException("9055", "userid不正确");
		}
		}catch(Exception e) {
			throw new BussinessException("9056", "userid加密错误");
		}
		activityMsgBean.setUserid(userid);
	}
	
	public void checkAsynMob(AsynOrderBean asynOrderBean) throws BussinessException {
		String userid = asynOrderBean.getUserid();
		if(StringUtils.isEmpty(userid)) {
			throw new BussinessException("9054", "userid不能为空");
		}
		String pwd = channelDao.queryChannel(asynOrderBean.getChannel()).getPassword();
		try {
			userid = DesUtil.decode(userid, pwd);
			if(userid.length() > 11) {
				userid = AESUtil.decrypt(userid, MOB_KEY);
			}
		if(!UsermobUtil.isValid(userid)) {
			throw new BussinessException("9055", "userid不正确");
		}
		}catch(Exception e) {
			throw new BussinessException("9056", "userid加密错误");
		}
		asynOrderBean.setUserid(userid);
	}
	
	public void checkChannelMob(OrderInfo orderInfo) throws BussinessException {
		String userid = orderInfo.getUserid();
		if(StringUtils.isEmpty(userid)) {
			throw new BussinessException("9054", "userid不能为空");
		}
		String pwd = channelDao.queryChannel(orderInfo.getChannel()).getPassword();
		try {
			userid = DesUtil.decode(userid, pwd);
			if(userid.length() > 11) {
				userid = AESUtil.decrypt(userid, MOB_KEY);
			}
		if(!UsermobUtil.isValid(userid)) {
			throw new BussinessException("9055", "userid不正确");
		}
		}catch(Exception e) {
			throw new BussinessException("9056", "userid加密错误");
		}
		orderInfo.setUserid(userid);
	}
	
	public static void main(String[] args) throws Exception {
		//System.out.println(AESUtil.decrypt(DesUtil.decode("OK/gxtIwbo+FqWTQjiyvTj8DiO4OvaUebC5fDw+MrAE28Ey/hAWi3A==", "tenc1234"), MOB_KEY));
		System.out.println(DesUtil.encode(AESUtil.encrypt("18574414678", MOB_KEY), "tenc1234"));
	}

}
