package com.chinacreator.video.service;

import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.VipLog;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.VipDao;
import com.chinacreator.video.util.RSAUtils;
import com.github.kevinsawicki.http.HttpRequest;

@Service
public class SohuVipService {
	
	//测试环境
//  private final static String VIPURL ="http://coop.store.sohu.com/test/tmall/thirdparty/directcharge";
	//正式环境
	private final static String VIPURL ="http://coop.store.sohu.com/tmall/thirdparty/directcharge/";
//	private final static String PUBLICKEY ="MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCsJlqHN/kzT3Zix+0zAE1q+r5ZPbIGJjlF1fFhxRwEsBSE+TL9TDUsUJ2V+VL5DqyGhConm68ny2JpMft/Fwyv52w9X2eHcp3rY334svMWt7SP+xB8YQUMBjGA0m9k0QmFgePSHarcq+hwOsy043lZ9UKVee7n2jTWz/zhmBKGRwIDAQAB";
	private final static String PUBLICKEY ="MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCLcLCpOARXQk6tC1/Is98HhK7bUMXoDMMUVy1FFLjUH7lz7srLb+laxdfOEfHXCom36K5H5GY54VWuxfW1SwdZ1K/xUiuvAsCOEmxUoKqurUIL7Q3RugCgaC/8LEOkaQvEns2/CRGQcT4wZRd4LI441gYrgV3b27WK9y6j38nUpQIDAQAB";
//	private final static String THIRDPARTY ="liantong_sohuvip";
	private final static String THIRDPARTY ="chinaunicom_wo_vip";
//	private final static Long COMMODITYID_7 = 546734642328L;
//	private final static Long COMMODITYID_31 = 546734642329L;
	private final static Long COMMODITYID_WO_31 = 546734642363L;
//	private final static Long COMMODITYID_93 = 546734642330L;
//	private final static Long COMMODITYID_365 = 546734642331L;
	private final static Long NUM = 1L;
//	private final static Long PRICE1 = 250L;  //单位： 分
	private final static Long PRICE2 = 990L;
//	private final static Long PRICE3 = 2500L;
//	private final static Long PRICE4 = 8400L;
    
	private static final Logger log = LoggerFactory.getLogger("viplog");
	
	@Autowired
	private SysDao sysDao;
	
	@Autowired
	private VipDao vipDao;

	@Autowired
	VipControlService vipControlService;
	
	public void giveVip(VipInfo activityInfo)throws BussinessException {
		this.vipControlService.canGiveVip(activityInfo);

		VipLog vipLog = new VipLog();
		vipLog.setResultcode("0");
		vipLog.setErrorinfo("");
		vipLog.setUserid(activityInfo.getUserid());
		vipLog.setActivityType(activityInfo.getActivetype());
		vipLog.setUsertype(activityInfo.getUsertype());
		vipLog.setType(activityInfo.getType());
		vipLog.setUserval(activityInfo.getUserval());
		
        //订单重试
        boolean flagCorp=false;
        String toCorpOrderid=null;
        if(activityInfo.getVippool()!=null && !"".equals(activityInfo.getVippool().trim())){
        	toCorpOrderid =  vipDao.getOrderId2(activityInfo.getUserid(), activityInfo.getActivetype(),activityInfo.getVippool());
        }else{
        	toCorpOrderid =  vipDao.getOrderId(activityInfo.getUserid(), activityInfo.getActivetype());
        }
        if(toCorpOrderid != null && !"".equals(toCorpOrderid)){
        	flagCorp=true;
        }

		try {
			Map<String, Object> param = new HashMap<>();
			vipLog.setVipdays("31");
			
			//重试订单
			String order_id = null;
			if(flagCorp){
				order_id = toCorpOrderid;
			}else{
				order_id = this.sysDao.getId();
			}
			
			String begintime = this.sysDao.getSysTime();
			String endtime = this.sysDao.getLastDay();

			vipLog.setOrderid(order_id);
			vipLog.setBegintime(begintime);
			vipLog.setEndtime(endtime);
			
			String userAccount = activityInfo.getUserval();
			Long commodityid = COMMODITYID_WO_31;
            Long price = PRICE2;
			
			param.put("userAccount",userAccount);
            param.put("commodityId",commodityid);
            param.put("num",NUM);
            param.put("orderID",order_id);
            param.put("price",price);
            param.put("thirdParty",THIRDPARTY);

            log.debug("============签名前查询字符串============");

            //签名加密
            String sign = RSAUtils.genSign(commodityid,NUM,order_id,price,THIRDPARTY,userAccount,PUBLICKEY);
            param.put("sign",sign);

            String url = VIPURL ;
            
            String result = null;
            try {
            	log.debug(url);
                vipLog.setOutput(JSON.toJSONString(param));
                HttpRequest httpRequest = new HttpRequest(url,"POST").header("thirdParty",THIRDPARTY).contentType("application/x-www-form-urlencoded").form(param);
                result = new String(httpRequest.bytes(), Charset.forName("UTF-8"));
//              result = "{\"status\":200,\"statusText\":\"OK\",\"data\":{\"orderSn\":\"1812211600FOVVCPXNOV\",\"chargeTime\":\"20181221171250\",\"chargeStatus\":0}}";
                vipLog.setReturnput(result);
                log.debug(result);
            } catch (Exception e) {
                vipLog.setResultcode("9070");
                vipLog.setErrorinfo("赠送会员超时或异常");
                throw new BussinessException("9070", "赠送会员超时或异常。");
            }
            JSONObject obj = JSON.parseObject(result);
            
            //解析返回结果
            String msg = obj.getString("statusText");
            String code = obj.getString("status");
            JSONObject data = (JSONObject) obj.get("data");
            String chargeStatus = "";
            if (data != null) {
                chargeStatus = data.getString("chargeStatus");
            }
            if("0".equals(code)){
            	code="-0";
            }
            
            //订单是否成功
			boolean flagvip = false;
			if("200".equals(code) && "0".equals(chargeStatus)){
				flagvip=true;
			}
			
			try {
				//把原有的9070订单标记失败
				if(flagCorp && flagvip && vipDao.getCount9070(activityInfo.getUserid(), toCorpOrderid)>0){
					vipDao.updateOrderIdAll(activityInfo.getUserid(), toCorpOrderid, "1","订单重试表明：此订单失败");
				}
			} catch (Exception e) {
				e.printStackTrace();
			}

			vipLog.setResultcode(flagvip?"0":code);
			vipLog.setErrorinfo(msg);
			this.vipControlService.saveVipGive(activityInfo, vipLog.getResultcode());
			if (!flagvip) {
				throw new BussinessException("9071", "赠送会员失败(" + msg + ")");
			}
		} catch (Exception e) {
			e.printStackTrace();
			if (e instanceof BussinessException)
				throw (BussinessException) e;
			else
				throw new BussinessException("8000", e.getMessage());
		} finally {
			log.info(JSON.toJSONString(vipLog));
			saveLog(vipLog);
		}
	}
	
	public void saveLog(VipLog vipLog) {
 		//vipLog.setResultcode("1");
		
		if(vipLog.getResultcode()==null){
			vipLog.setResultcode("");
		}
		if(vipLog.getErrorinfo()==null){
			vipLog.setErrorinfo("");
		}
		vipDao.insert(vipLog);
	}

}
