package com.chinacreator.video.service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.CpSpBean;
import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.bean.WhiteBean;
import com.chinacreator.video.dto.QueryDataOutPipe;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.log.OrderLog;
import com.chinacreator.video.mapper.ActiveDao;
import com.chinacreator.video.mapper.AreaDao;
import com.chinacreator.video.mapper.CpSpDao;
import com.chinacreator.video.mapper.OrderDao;
import com.chinacreator.video.mapper.OrderLogDao;
import com.chinacreator.video.mapper.PreOrderDao;
import com.chinacreator.video.mapper.QueryOrderDao;
import com.chinacreator.video.mapper.QueryPreOrderDao;
import com.chinacreator.video.mapper.SysDao;
import com.chinacreator.video.mapper.WhiteDao;
import com.chinacreator.video.util.VacUtil;

@Component
public class TestOrderService {
	
	@Autowired
	private ComonService comonService;
	
	@Autowired
	private CpSpService cpSpService;
	
	@Autowired
	private MobService mobService;
	
	@Autowired
	private OrderDao orderDao;
	
	@Autowired
	private PreOrderDao preOrderDao;
	
	@Autowired
	private WhiteDao whiteDao;
	
	@Autowired
	private CpSpDao cpSpDao;
	
	@Autowired
	private SysDao sysDao;
	
	@Autowired
	private AreaDao areaDao;

	@Autowired
	private QueryOrderDao queryOrderDao;
	
	@Autowired
	private ActiveDao activeDao;
	
	@Autowired
	private OrderLogDao orderLogDao;
	
	@Autowired
	private QueryPreOrderDao queryPreOrderDao;
	
	@Autowired
	private EcbService ecbService;
	
	@Autowired
	private VacControlService vacControlService;
	
	public void orderCheck(OrderInfo orderInfo) throws BussinessException {
		comonService.checkOrder(orderInfo);
		cpSpService.checkSp(orderInfo);
		mobService.checkMob(orderInfo);
		Map<String,String> map = areaDao.getArea(orderInfo.getUserid());
		if(map != null) {
			orderInfo.setProvince(map.get("province") == null ? "" : map.get("province"));
			orderInfo.setArea(map.get("area") == null ? "" : map.get("area"));
		}
		if(orderInfo.getCpid().equals("twowei")) {
			if(orderInfo.getCanceltype()==1) {
				orderInfo.setCpid("tencent");
				orderInfo.setSpid("6");
			}else {
				orderInfo.setCpid("tencent");
				orderInfo.setSpid("84");
			}
		}
		if(orderInfo.getProvince() != null && orderInfo.getProvince().equals("云南")){
			throw new BussinessException("9069", "该省份暂未开放，请稍后再试");
		}
	}
	
	public void order(OrderInfo orderInfo) throws Exception {
		String resultcode ="0";
		String errrorinfo="";
		try {
		List<OrderInfo> localOrderInfos = orderDao.getOrderByUserid(orderInfo.getUserid());
		CpSpBean cpspBean = cpSpDao.getCpSp(orderInfo.getCpid(),orderInfo.getSpid());
		OrderInfo oldorderInfo = null;
		if(localOrderInfos != null && localOrderInfos.size()>0) {
			for (OrderInfo localOrderInfo : localOrderInfos) {
				if(localOrderInfo.getSpid().equals(orderInfo.getSpid()) &&  localOrderInfo.getStatus() == 0) {
					throw new BussinessException("9060", "用户已订购");
				}else if(localOrderInfo.getSpid().equals(orderInfo.getSpid()) && localOrderInfo.getStatus() != 0 && NumberUtils.toLong(localOrderInfo.getCanceltime().substring(0, 6))==NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss").substring(0, 6))) {
					oldorderInfo = localOrderInfo;
					if(localOrderInfo.getCancelchannel() != null && (localOrderInfo.getCancelchannel().equals("lvac") || localOrderInfo.getCancelchannel().equals("ecb"))) {
						oldorderInfo.setStatus(2);
					}
				}else if(localOrderInfo.getSpid().equals(orderInfo.getSpid()) &&  localOrderInfo.getStatus() == 1 && NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"))<NumberUtils.toLong(localOrderInfo.getCanceltime())){
					throw new BussinessException("9065", "订购时间早于退订时间");
				}else {
					String[] mutexs = orderInfo.getMutex() == null ? null : orderInfo.getMutex().trim().split(",");
					if(mutexs != null && mutexs.length>0 &&  Arrays.asList(mutexs).contains(localOrderInfo.getSpid())) {
						throw new BussinessException("9061", "用户已订购相同产品或者未失效");
					}
				}
			}
		}
		WhiteBean whiteBean = whiteDao.getUser(orderInfo.getUserid(),orderInfo.getCpid());
		if(whiteBean != null) {
			if(whiteBean.getType().equals("1")) {
				throw new BussinessException("9065", "黑名单用户禁止订购");
			}
		}
		if(oldorderInfo == null || (oldorderInfo!= null && oldorderInfo.getStatus()==2)) {
			if(whiteBean!=null && whiteBean.getVac().equals("1")) {
				ecbService.queryEcb(orderInfo.getUserid(), orderInfo.getCpid(), orderInfo.getSpid(), orderInfo.getProvince());
				vacControlService.checkOrdered(orderInfo);
				String result = VacUtil.vac(orderInfo.getUserid(), cpspBean.getSpcode(), cpspBean.getVacproductid(),cpspBean.getType());
				vacControlService.saveVacOrder(orderInfo, result);
				if(!result.equals("0")) {
					throw new BussinessException(result, "订购失败，VAC错误");
				}
			}
		}
		orderInfo.setOrdertime(sysDao.getSysTime());
		orderInfo.setEffecttime(sysDao.getEfftTime());
		orderInfo.setOrderchannel(orderInfo.getChannel());
		orderDao.order(orderInfo);
		if(orderInfo.getCpid().equals("tencent") && orderInfo.getSpid().equals("84")) {
		if(oldorderInfo == null || oldorderInfo.getStatus()==2) {
			activeDao.orderActivity(getActivityBean(orderInfo,0));
		}else {
			activeDao.orderActivity(getActivityBean(orderInfo,1));
		}
		}
		}catch(Exception e) {
			resultcode = "8000";
			errrorinfo ="系统忙,请稍后再试";
			if ((e instanceof BussinessException)) {
				resultcode = ((BussinessException) e).getCode();
				errrorinfo = ((BussinessException) e).getMessage();
				if(errrorinfo.length()>200){
					errrorinfo = errrorinfo.substring(0, 200);
				}
			}
			throw e;
		}finally {
			saveLog(orderInfo, resultcode, errrorinfo,"0");
		}
	}
	
	public ActivityBean getActivityBean(OrderInfo orderInfo,int type) {
		ActivityBean bean = new ActivityBean();
		bean.setUserid(orderInfo.getUserid());
		bean.setCpid(orderInfo.getCpid());
		bean.setSpid(orderInfo.getSpid());
		bean.setProvince(orderInfo.getProvince());
		bean.setOrdertime(orderInfo.getOrdertime());
		bean.setArea(orderInfo.getArea());
		bean.setActiveType("6");
		bean.setOrderchannel(orderInfo.getOrderchannel());
		if(type == 0) {
			bean.setType("0");
			bean.setVipstatus("2");
		}else {
			bean.setType("1");
		}
		System.out.println(JSON.toJSONString(bean));
		return bean;
	}
	
	public ActivityBean getCacenlActivityBean(OrderInfo orderInfo) {
		ActivityBean bean = new ActivityBean();
		bean.setUserid(orderInfo.getUserid());
		bean.setCpid(orderInfo.getCpid());
		bean.setSpid(orderInfo.getSpid());
		bean.setActiveType("6");
		bean.setCancelchannel(orderInfo.getCancelchannel());
		bean.setCanceltime(orderInfo.getCanceltime());
		bean.setEndtime(orderInfo.getEndtime());
		return bean;
	}
	
	public void preOrder(OrderInfo orderInfo)throws Exception  {
		OrderInfo localOrderInfo = preOrderDao.getOrder(orderInfo.getUserid(),orderInfo.getCpid(),orderInfo.getSpid());
		OrderInfo oldorderInfo = null;
		if(localOrderInfo != null) {
			if(localOrderInfo.getSpid().equals(orderInfo.getSpid()) && localOrderInfo.getStatus() == 0) {
				throw new BussinessException("9062", "用户已预订购");
			}
			if(localOrderInfo.getSpid().equals(orderInfo.getSpid()) && localOrderInfo.getStatus() != 0 && NumberUtils.toLong(localOrderInfo.getCanceltime().substring(0, 6))==NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss").substring(0, 6))) {
				oldorderInfo = localOrderInfo;
				if (localOrderInfo.getCancelchannel() !=null &&(localOrderInfo.getCancelchannel().equals("lvac") || localOrderInfo.getCancelchannel().equals("ecb"))) {
					oldorderInfo.setStatus(2);
				}
			}
		}
		WhiteBean whiteBean = whiteDao.getUser(orderInfo.getUserid(),orderInfo.getCpid());
		if(whiteBean != null) {
			if(whiteBean.getType().equals("1")) {
				throw new BussinessException("9065", "黑名单用户禁止订购");
			}
		}
		orderInfo.setOrdertime(sysDao.getSysTime());
		orderInfo.setEffecttime(sysDao.getEfftTime());
		orderInfo.setOrderchannel(orderInfo.getChannel());
		CpSpBean cpspBean = cpSpDao.getCpSp(orderInfo.getCpid(),orderInfo.getSpid());
		if(orderInfo.getOrdertype() == 5) {
			orderInfo.setOrdertype(1);
			if(oldorderInfo == null || (oldorderInfo!= null && oldorderInfo.getStatus()==2)) {
				if(whiteBean!=null && whiteBean.getVac().equals("1")) {
					ecbService.queryEcb(orderInfo.getUserid(), orderInfo.getCpid(), orderInfo.getSpid(), orderInfo.getProvince());
					vacControlService.checkOrdered(orderInfo);
					String result = VacUtil.vac(orderInfo.getUserid(), cpspBean.getSpcode(), cpspBean.getVacproductid(),cpspBean.getType());
					vacControlService.saveVacOrder(orderInfo, result);
					if(!result.equals("0")) {
						throw new BussinessException(result, "订购失败，VAC错误");
					}
				}
			}
		}else {
			orderInfo.setOrdertype(0);
		}
		preOrderDao.order(orderInfo);
		if(orderInfo.getOrdertype() == 1) {
			if(orderInfo.getCpid().equals("tencent") && orderInfo.getSpid().equals("84")) {
				if(oldorderInfo == null || oldorderInfo.getStatus()==2) {
					activeDao.orderActivity(getActivityBean(orderInfo,0));
				}else {
					activeDao.orderActivity(getActivityBean(orderInfo,1));
				}
			}
		}
	}
	
	public void cancel(OrderInfo orderInfo) throws Exception{
		System.out.println(JSON.toJSONString(orderInfo));
		String resultcode ="0";
		String errrorinfo="";
		try {
			OrderInfo localOrderInfo = orderDao.getOrder(orderInfo);
			if(localOrderInfo == null ) {
				throw new BussinessException("9063", "用户没有订购");
			}
			if(localOrderInfo.getStatus() == 1) {
				throw new BussinessException("9064", "用户已退订");
			}
			
			WhiteBean whiteBean = whiteDao.getUser(orderInfo.getUserid(),orderInfo.getCpid());
			if(whiteBean != null) {
				if(whiteBean.getType().equals("1")) {
					throw new BussinessException("9065", "黑名单用户禁止操作");
				}
			}
			if(orderInfo.getCanceltype()==1 && (whiteBean==null || whiteBean.getVac().equals("1"))) {
				CpSpBean cpspBean = cpSpDao.getCpSp(orderInfo.getCpid(),orderInfo.getSpid());
				String result = VacUtil.vac(orderInfo.getUserid(), cpspBean.getSpcode(), cpspBean.getVacproductid(),"2");
				if(!result.equals("0")) {
					throw new BussinessException(result, "退订失败，VAC错误");
				}
			}
			
			orderInfo.setCanceltime(sysDao.getSysTime());
			orderInfo.setEndtime(sysDao.getLastDay());
			orderInfo.setCancelchannel(orderInfo.getChannel());
			orderDao.cancel(orderInfo);
			if(orderInfo.getCpid().equals("tencent") && orderInfo.getSpid().equals("84")) {
				activeDao.canceActivity(getCacenlActivityBean(orderInfo));
			}
		}catch(Exception e) {
			resultcode = "8000";
			errrorinfo ="系统忙,请稍后再试";
			if ((e instanceof BussinessException)) {
				resultcode = ((BussinessException) e).getCode();
				errrorinfo = ((BussinessException) e).getMessage();
				if(errrorinfo.length()>200){
					errrorinfo = errrorinfo.substring(0, 200);
				}
			}
			throw e;
		}finally {
			saveLog(orderInfo, resultcode, errrorinfo, "1");
		}
	}
	
	public void preCancel(OrderInfo orderInfo)throws BussinessException {
		System.out.println("==================>"+JSON.toJSONString(orderInfo));
		OrderInfo localOrderInfo = preOrderDao.getOrder(orderInfo.getUserid(),orderInfo.getCpid(),orderInfo.getSpid());
		if(localOrderInfo == null ) {
			throw new BussinessException("9067", "用户没有订购");
		}
		if(localOrderInfo.getStatus() == 1) {
			throw new BussinessException("9068", "已取消预订购");
		}
		if(NumberUtils.toLong(localOrderInfo.getOrdertime()) > NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"))) {
			throw new BussinessException("9066", "退订时间早于顶偶时间");
		}
		orderInfo.setCanceltime(sysDao.getSysTime());
		orderInfo.setEndtime(sysDao.getLastDay());
		orderInfo.setCancelchannel(orderInfo.getChannel());
		preOrderDao.cancel(orderInfo);
		if(orderInfo.getCanceltype() == 5) {
			if(orderInfo.getCpid().equals("tencent") && orderInfo.getSpid().equals("84")) {
				activeDao.canceActivity(getCacenlActivityBean(orderInfo));
			}
		}
	}
	
	public List<QueryDataOutPipe> queryOrder(OrderInfo orderInfo){
		List<QueryDataOutPipe> list = new ArrayList<>();
		List<QueryDataOutPipe> listQueryDataOutPipe = queryOrderDao.getOrder(orderInfo);
		if(listQueryDataOutPipe != null && listQueryDataOutPipe.size()>0) {
			for (QueryDataOutPipe queryDataOutPipe : listQueryDataOutPipe) {
				list.add(queryDataOutPipe);
			}
		}
		List<QueryDataOutPipe> prelistQueryDataOutPipe = queryPreOrderDao.getOrder(orderInfo);
		if(prelistQueryDataOutPipe != null && prelistQueryDataOutPipe.size()>0) {
			for (QueryDataOutPipe queryDataOutPipe : prelistQueryDataOutPipe) {
				if(queryDataOutPipe.getOrderstatus().equals("0")) {
					queryDataOutPipe.setOrderstatus("2");
				}else {
					queryDataOutPipe.setOrderstatus("3");
				}
				list.add(queryDataOutPipe);
			}
		}
		return list;
	}
	
	public void saveLog(OrderInfo orderInfo,String resultCode,String errorInfo,String type) {
		OrderLog orderLog = new OrderLog();
		orderLog.setApptype("");
		if(type.equals("0")) {
			orderLog.setStatus(0);
			orderLog.setChannel(orderInfo.getOrderchannel());
			orderLog.setOrderstatus(2);
		}else {
			orderLog.setStatus(1);
			orderLog.setChannel(orderInfo.getCancelchannel());
			orderLog.setOrderstatus(4);
		}
		orderLog.setArea(orderInfo.getArea());
		orderLog.setCpid(orderInfo.getCpid());
		orderLog.setIsexperience(orderInfo.getIsexperience());
		orderLog.setOrdertype(orderInfo.getOrdertype() + "");
		orderLog.setProvince(orderInfo.getProvince());
		orderLog.setArea(orderInfo.getArea());
		orderLog.setSpid(orderInfo.getSpid());
		orderLog.setUserid(orderInfo.getUserid());
		orderLog.setErrorcode(resultCode);
		orderLog.setErrorinfo(errorInfo);
		if(StringUtils.isNotEmpty(orderInfo.getTimes())){
			orderLog.setTimes((System.currentTimeMillis()-NumberUtils.toLong(orderInfo.getTimes()))+"");
		}
		System.out.println("orderLog="+JSON.toJSONString(orderLog));
		orderLogDao.insertLog(orderLog);
	}
}
