package com.chinacreator.video.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.chinacreator.video.bean.OrderInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.VacOrderDao;
import com.chinacreator.video.redis.RedisService;

@Component
public class VacControlService {

	@Autowired
	private RedisService redisService;

	@Autowired
	private VacOrderDao vacOrderDao;

	public void canOrder(OrderInfo orderInfo) throws BussinessException {
		try {
			if ((orderInfo.getCpid().equals("tencent")
					&& (orderInfo.getSpid().equals("84") || orderInfo.getSpid().equals("85")
							|| orderInfo.getSpid().equals("86") || orderInfo.getSpid().equals("87")
							|| orderInfo.getSpid().equals("88") || orderInfo.getSpid().equals("89")))
					|| (orderInfo.getCpid().equals("cctv") && orderInfo.getSpid().equals("10081"))) {
				checkRedis(orderInfo);
				checkOrdered(orderInfo);
			}
		} catch (Exception e) {
			e.printStackTrace();
			if (e instanceof BussinessException) {
				throw e;
			}
		}
	}

	public boolean isVac(OrderInfo orderInfo) {
		String countnum = vacOrderDao.getOrderInfo(orderInfo.getUserid(), orderInfo.getCpid(), orderInfo.getSpid());
		if (countnum.equals("0")) {
			return true;
		} else {
			return false;
		}
	}

	public void checkRedis(OrderInfo orderInfo) throws BussinessException {
		long count = redisService
				.incr("vac_" + orderInfo.getCpid() + "_" + orderInfo.getSpid() + "_" + orderInfo.getUserid());
		if (count > 1) {
			throw new BussinessException("8001", "并发请求，请稍后再试");
		}
	}

	public void checkOrdered(OrderInfo orderInfo) throws BussinessException {
		String countnum = vacOrderDao.getOrderInfo(orderInfo.getUserid(), orderInfo.getCpid(), orderInfo.getSpid());
		if (!countnum.equals("0")) {
			throw new BussinessException("8002", "重复vac请求，请稍后再试");
		}
	}

	public void saveVacOrder(OrderInfo orderInfo, String result) {
		try {
			if ((orderInfo.getCpid().equals("tencent")
					&& (orderInfo.getSpid().equals("84") || orderInfo.getSpid().equals("85")
							|| orderInfo.getSpid().equals("86") || orderInfo.getSpid().equals("87")
							|| orderInfo.getSpid().equals("88") || orderInfo.getSpid().equals("89")))
					|| (orderInfo.getCpid().equals("cctv") && orderInfo.getSpid().equals("10081"))) {
				if (result.equals("0")) {
					vacOrderDao.insertOrderInfo(orderInfo);
				}
				redisService.removeKey(
						"vac_" + orderInfo.getCpid() + "_" + orderInfo.getSpid() + "_" + orderInfo.getUserid());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
