package com.chinacreator.video.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.VipGiveDao;
import com.chinacreator.video.redis.RedisService;

@Component
public class VipControlService {

	@Autowired
	private RedisService redisService;

	@Autowired
	private VipGiveDao vipGiveDao;

	public void canGiveVip(VipInfo vipInfo) throws BussinessException {
		try {
			checkRedis(vipInfo);
			checkGiveed(vipInfo);
		} catch (Exception e) {
//			e.printStackTrace();
			if (e instanceof BussinessException) {
				throw e;
			}
		}
	}

	public void checkRedis(VipInfo vipInfo) throws BussinessException {
		long count = redisService.incr("vip_" + vipInfo.getCpid() + "_" + vipInfo.getSpid() + "_" + vipInfo.getUserid());
		if (count > 1) {
			throw new BussinessException("8003", "赠送会员并发请求，请稍后再试");
		}
	}

	public void checkGiveed(VipInfo vipInfo) throws BussinessException {
		String countnum = null;
	    if ("4".equals(vipInfo.getSptype()))
	      countnum = this.vipGiveDao.getVipGiveInfoGroup(vipInfo.getUserid(), vipInfo.getCpid(), vipInfo.getSpid(), vipInfo.getActivetype());
	    else {
	      countnum = this.vipGiveDao.getVipGiveInfo(vipInfo.getUserid(), vipInfo.getCpid(), vipInfo.getSpid(), vipInfo.getActivetype());
	    }
		if (!countnum.equals("0")) {
			throw new BussinessException("8004", "重复领取会员请求，请稍后再试");
		}
	}

	public void saveVipGive(VipInfo vipInfo, String result) {
		try {
			if (result.equals("0")) {
				if (vipInfo.getActivetype().equals("18")) {
					vipGiveDao.insertVipGiveInfo(vipInfo.getUserid(), vipInfo.getCpid(), vipInfo.getSpid(), "1", vipInfo.getActivetype());
				} else {
					vipGiveDao.insertVipGiveInfo(vipInfo.getUserid(), vipInfo.getCpid(), vipInfo.getSpid(), "", vipInfo.getActivetype());
				}
			}
			redisService.removeKey("vip_" + vipInfo.getCpid() + "_" + vipInfo.getSpid() + "_" + vipInfo.getUserid());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * 三选一产品已经领取了几个
	 * 
	 * @param activetype
	 * @param userval
	 * @param orderid
	 * @param count
	 * @return
	 */
	public boolean vipMultiCanGive(String activetype, String userid,String orderid ,int count) {
		try {
			int i = vipGiveDao.getVipMultiCount(userid, activetype, orderid);
			if(i<count) {
				return true;
			}else {
				return false;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return false;
	}

}
