package com.chinacreator.video.service;


import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ActiveHBDao;
import com.chinacreator.video.redis.RedisService;
import com.chinacreator.video.util.AESUtil;
import com.chinacreator.video.util.DesUtil;
import com.chinacreator.video.util.HxVipTwUtil;
import com.chinacreator.video.util.MD5;
import com.chinacreator.video.util.SHAUtil;
import com.chinacreator.video.util.URLUtil;
import com.chinacreator.video.util.UsermobUtil;

@Component
public class VipHBService {
	
	private static Logger ErrorLOGGER = LoggerFactory.getLogger("ERROR");
	//redis计数
	private static String key = "joinvip_hb_7_4get1_631_";
	
	//活动代码
	private static String  activetype = "631";
	private static String  active_pwd = "ei3s02rn";
	private static final String MOB_KEY = "ac22273abb2f4960";
	
	//会员直充
	private static String orderid = "hb7days4get12020_";
	private static String vippwd="5b9nS70P";
	private static String vipchannel="vipHB";
	
	//发送短信
	private static String smsurl="http://111.206.133.54/smsbusi/sms/send";
	private static String smsid="1065511763";
	private static String smspwd="S5o0B8E7";
	private static String smscontent="hb10655117631";
	
	@Autowired
	private RedisService redisService;
	
	@Autowired
	private ComonService comonService;


	@Autowired
	private ActivityConfigService activityService;
	
	@Autowired
	private ActiveHBDao activeDao;
	@Autowired
	private HxVipTwUtil hxVipTwUtil;
	/**
	 * 领取校验
	 * 
	 * @param vipInfo
	 * @throws BussinessException
	 */
	public void checkVipQuery(VipInfo vipInfo) throws BussinessException {
		this.checkRedis(vipInfo,"join");
		comonService.checkTimestamp(vipInfo.getTimestamp());
		activityService.checkActivity(vipInfo);
		this.checkSignQuery(vipInfo);
		this.checkVipMob(vipInfo);
		this.checkRedisJoin(vipInfo);
		this.checkHB(vipInfo);
	}
	
	public void checkVipJoin(VipInfo vipInfo) throws BussinessException {
		this.checkRedis(vipInfo,"query");
		comonService.checkTimestamp(vipInfo.getTimestamp());
		activityService.checkActivity(vipInfo);
		this.checkSignJoin(vipInfo);
		this.checkVipMob(vipInfo);
		this.checkRedisJoin(vipInfo);
		this.checkHB(vipInfo);
	}
	
	public void clearRedis(VipInfo vipInfo) throws BussinessException {
		redisService.removeKey( key + vipInfo.getUserid());
	}
	
	
	/**
	 * 并发控制
	 * @param vipInfo
	 * @throws BussinessException
	 */
	public void checkRedis(VipInfo vipInfo,String type) throws BussinessException {
		try {
			long count = redisService.incr( key + type + "_"+ vipInfo.getUserid());
			if (count > 1) {
				throw new BussinessException("8001", "并发请求，请稍后再试");
			}
		} catch (Exception e) {
			if (e instanceof BussinessException) {
				throw e;
			}else{
				ErrorLOGGER.error("", e);  
			}
		}
	}
	
	public void checkRedisJoin(VipInfo vipInfo) throws BussinessException {
		try {
			long count = redisService.incrAdd( key + vipInfo.getUserid(),3600L*24L*365L);
			System.out.println(key + vipInfo.getUserid()+"="+count);
			ErrorLOGGER.info(key + vipInfo.getUserid()+"="+count);
			if (count > 1) {
				throw new BussinessException("6084", "已经领取过");
			}
			
			redisService.removeKey( key + vipInfo.getUserid());;
		} catch (Exception e) {
			if (e instanceof BussinessException) {
				throw e;
			}else{
				ErrorLOGGER.error("", e);  
			}
		}
	}
	
	public void addRedisJoin(VipInfo vipInfo) throws BussinessException {
		try {
			long count = redisService.incrAdd( key + vipInfo.getUserid(),3600L*24L*365L);
			System.out.println(key + vipInfo.getUserid()+"="+count);
			ErrorLOGGER.info(key + vipInfo.getUserid()+"="+count);
		} catch (Exception e) {
			if (e instanceof BussinessException) {
				throw e;
			}else{
				ErrorLOGGER.error("", e);  
			}
		}
	}
	
	
	public void checkSignQuery(VipInfo activityInfo) throws BussinessException {
		String sign = activityInfo.getSignature();
		if (StringUtils.isEmpty(sign)) {
			throw new BussinessException("9054", "signature不能为空");
		}
		String localSign = MD5.MD5Encode(activityInfo.getUserid() + activityInfo.getActivetype() + active_pwd + activityInfo.getTimestamp());
		if (!localSign.equals(sign)) {
			throw new BussinessException("9054", "signature校验失败");
		}
	}
	
	public void checkSignJoin(VipInfo activityInfo) throws BussinessException {
		String sign = activityInfo.getSignature();
		if (StringUtils.isEmpty(sign)) {
			throw new BussinessException("9054", "signature不能为空");
		}
		String localSign = MD5.MD5Encode(activityInfo.getUserid() + activityInfo.getActivetype() + activityInfo.getType() + active_pwd + activityInfo.getTimestamp());
		if (!localSign.equals(sign)) {
			throw new BussinessException("9054", "signature校验失败");
		}
	}
	
	public void checkVipMob(VipInfo activityInfo) throws BussinessException {
		String userid = activityInfo.getUserid();
		if(StringUtils.isEmpty(userid)) {
			throw new BussinessException("9054", "userid不能为空");
		}
		try {
			userid = DesUtil.decode(userid, active_pwd);
			if(userid.length() > 11) {
				userid = AESUtil.decrypt(userid, MOB_KEY);
			}
			if(!UsermobUtil.isValid(userid)) {
				throw new BussinessException("9055", "userid不正确");
			}
		}catch(Exception e) {
			throw new BussinessException("9056", "userid加密错误");
		}
		activityInfo.setUserid(userid);
	}
	
	
	/**
	 * 验证是否是湖北用户
	 * 
	 * @param vipInfo
	 * @throws BussinessException
	 */
	public void checkHB(VipInfo vipInfo) throws BussinessException {
		
		try {
			/**
			 * 查询号段
			 * 
			 */
			int i = activeDao.queryHB(vipInfo.getUserid().substring(0, 7));
			if(i<1){
				try {
					int j = activeDao.queryHBZW(vipInfo.getUserid());
					if(j<1) {
						throw new BussinessException("9083", "当前号码非湖北联通号段的号码");
					}
				} catch (Exception e) {
					e.printStackTrace();
					if (e instanceof BussinessException)
						throw (BussinessException) e;
					else
						throw new BussinessException("9083", "当前号码非湖北联通号段的号码");
				}
				
			}
		} catch (Exception e) {
			if (e instanceof BussinessException) {
				throw (BussinessException)e;
			}else{
				ErrorLOGGER.error("", e);  
				throw e;
			}
		}
	}
	

	
	/**
	 * 会员领取
	 * 
	 * @param activityInfo
	 * @throws BussinessException
	 */
	public void giveVip(VipInfo info) throws BussinessException {
		String channel  =  info.getChannel();
		if(channel==null) {
			channel = vipchannel;
		}else{
			channel = channel.trim();
			if(channel.length()>20){
				channel = channel.substring(0,20);
			}
		}
		
		//会员领取类型
		int type = info.getType();
		String viptype = "";
		if(type != 1 && type != 2 && type != 3 && type != 4 && type != 5) {
			throw new BussinessException("6082", "会员领取类型异常");
		}
		if(type==1){
			viptype = "tencent";
		}else if(type==2){
			viptype = "aiqy";
		}else if(type==3){
			viptype = "youku";
		}else if(type==4){
			viptype = "mango";
		}else if(type==5){
			viptype = "pptv";
		}
		String vipid = info.getSpid()+type;
		
		//是否已经领取
		int flag = activeDao.getJoinRecord(info.getUserid());
		if(flag > 0) {
			String status = activeDao.getRecordStatus(info.getUserid());
			if("0".contentEquals(status) || "1".contentEquals(status)) {
				throw new BussinessException("6081", "已经领取过或正在领取中");
			}
			
			int i = activeDao.updateJoinStatus(info.getUserid(), "1", viptype,"2",channel);
			if(i<1) {
				throw new BussinessException("6083", "会员领取失败");
			}
		}else {
			String id = new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date()) + String.valueOf((int)((Math.random()*9+1)*1000));
			int i = activeDao.insert(id, info.getUserid(), viptype, vipid, activetype, "1",channel);
			if(i<1) {
				throw new BussinessException("6083", "会员领取失败");
			}
		}
		
		
		//调用直充接口送会员
		try {
			String remark = null;
			if(type==1){
				remark = "会员产品";
			}
			
			String result = hxVipTwUtil.vipid(info.getUserid() ,vipid, channel, vippwd, "4", info.getUserid(), orderid+info.getUserid(), remark);
			JSONObject obj = JSON.parseObject(result);
			String resultcode = obj.getString("resultcode");
			String errorinfo = obj.getString("errorinfo");
			if(!"0".equals(resultcode) && !("10002".equals(resultcode) && "orderid不能重复使用".equals(errorinfo)) ){
				//会员失败
				activeDao.updateJoinStatus(info.getUserid(), "2",viptype, "1",channel);
				throw new BussinessException("8008","后台领取失败("+resultcode+","+errorinfo+")");
			}
		} catch (Exception e) {
			e.printStackTrace();
			if (e instanceof BussinessException)
				throw (BussinessException) e;
			else
				throw new BussinessException("8000", e.getMessage());
		}
		
		/**
		 * redis标记
		 */
		this.addRedisJoin(info);
		
		/**
		 * 发送短信
		 */
		this.sendSMS(info.getUserid(), type);
		
		//会员成功
		activeDao.joinSucceed(info.getUserid(), "0");
	}
	
	
	public void queryVip(VipInfo info) throws BussinessException {
//		//会员领取类型
//		int type = info.getType();
//		if(type != 1 && type != 2 && type != 3 && type != 4) {
//			throw new BussinessException("6082", "会员领取类型异常");
//		}
		
		//是否已经领取
		int flag = activeDao.getJoinRecord(info.getUserid());
		if(flag > 0) {
			String status = activeDao.getRecordStatus(info.getUserid());
			if("0".contentEquals(status) || "1".contentEquals(status)) {
				throw new BussinessException("6081", "已经领取过或正在领取中");
			}
		}
		
	}
	
	/**
	 * 发送短信
	 * 
	 * @param usermob
	 * @param content
	 * @return
	 */
	private void sendSMS (String usermob, int type){
		try {
			String timestamp = new Date().getTime()/1000+"";
			String userid =  DesUtil.encode(usermob,  smspwd);
			String contentid = smscontent+type;
			String sign = SHAUtil.shaEncode(smsid+userid+timestamp+contentid+smspwd).toLowerCase();
			
			userid = URLEncoder.encode(userid,"utf-8");
			String url = "?userid="+userid+"&smsid="+smsid+"&timestamp="+timestamp+"&sign="+sign+"&contentid="+contentid;
			String resp = URLUtil.get(smsurl+url);
			System.out.println(resp);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
}
