package com.chinacreator.video.service;


import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import com.chinacreator.video.bean.*;
import com.chinacreator.video.controller.Activity;
import com.chinacreator.video.mapper.*;

import com.chinacreator.video.redis.RedisService;
import com.chinacreator.video.util.IpAddrUtil;
import com.chinacreator.video.util.IpUtil;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.chinacreator.video.dto.QueryVipLogOutPipe;
import com.chinacreator.video.exception.BussinessException;
//import com.chinacreator.video.service.handle.Aiqy20GetVipService;
import com.chinacreator.video.service.handle.GetVipService;
import com.chinacreator.video.util.StrUtil;

import org.springframework.util.StringUtils;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

@Component
public class VipService {

    private static final Logger log = LoggerFactory.getLogger("vipservice");

    @Autowired
    private ComonService comonService;

    @Autowired
    private MobService mobService;

    @Autowired
    private GiveVipService giveVipService;

    @Autowired
    private ActivityConfigService activityService;

    @Autowired
    private ActiveDao activeDao;

    @Autowired
    private UserMsgDao userMsgDao;

    @Autowired
    private PreOrderDao preOrdeDao;

    @Autowired
    private VipDao vipdao;

    @Autowired
    private VipWhiteDao vipWhiteDao;

    @Autowired
    private ActiveMangoFreeDao mangoFreeDao;

    @Autowired
    private ActivityVipConfigService vipConfigService;

    @Autowired
    private CtvGiveVipService ctvGiveVipService;

    @Autowired
    private AiqiyiGiveVipService aiqiyiGiveVipService;
//
//	@Autowired
//	private Aiqy20GetVipService aiqy20Service;

    @Autowired
    private GiveVipProvinceCrontrolDao giveVipProvinceCrontrolDao;

    @Autowired
    private AiqiyiGiveMonthVipService aiqiyiGiveMonthVipService;

    @Autowired
    private LeshiGiveVipService leshiGiveVipService;

    @Autowired
    private LeshiNewGiveVipService leshiNewGiveVipService;

    @Autowired
    private MangtvGiveVipService mangtvGiveVipService;

    @Autowired
    private MangtvFreeVipService mangtvFreeVipService;

    @Autowired
    private PptvGiveVipService pptvGiveVipService;

    @Autowired
    private Youku20VipService youku20VipService;

    @Autowired
    private WasuGiveVipService wasuVipService;

    @Autowired
    private Fushion12VipService fengx12VipService;

    @Autowired
    private SohuVipService sohuVipService;

    @Autowired
    private EcbService ecbService;

    @Autowired
    private EcbVipService ecbVipService;

    @Autowired
    private GetVipService getVipService;

    @Autowired
    JoinActivityDao joinActivityDao;

    @Autowired
    private CapKbxkQryService capKbxkQryService;

    @Autowired
    private SysDao sysDao;

    @Autowired
    OrderDao orderDao;

    @Autowired
    BlackListDao blackListDao;


    @Autowired
    VipJoinSpidDao vipJoinSpidDao;

    @Autowired
    VipReceiveDao vipReceiveDao;

    @Autowired
    private ActivityConfigDao activityConfigDao;

    @Autowired
    private VipGiveDao vipGiveDao;

    @Autowired
    private Activity activity;

    @Value("${config.joinActivity.orderChannels}")
    public String orderChannels;
    @Autowired
    private DictionaryDao dictionaryDao;

    @Autowired
    private RedisService redisService;

    @Autowired
    private ComplementSendDao complementSendDao;


    @Value("${config.joinActivity.tencentorderChannels}")
    public String tencentorderChannels;
    @Value("${config.joinActivity.tencentorderFreeChannels}")
    public String tencentorderFreeChannels;

    @Value("${config.joinActivity.spid.blacklist}")
    public String blackList;

    @Value("${config.joinActivity.mangtv1051orderChannels}")
    public String mangtv1051orderChannels;
    @Value("${config.joinActivity.mangtv1052orderChannels}")
    public String mangtv1052orderChannels;
    @Value("${config.joinActivity.tencent1244orderChannels}")
    public String tencent1244orderChannels;
    @Value("${config.joinActivity.tencent1016ThreeorderChannels}")
    public String tencent1016ThreeorderChannels;

    public void checkActity(VipInfo vipInfo) throws BussinessException {
        comonService.checkTimestamp(vipInfo.getTimestamp());
        activityService.checkActivity(vipInfo);
        comonService.checkGetVipSign(vipInfo);
        mobService.checkVipMob(vipInfo);
        if (vipInfo.getCpid().equals("twowei")) {
            if ("10011".equals(vipInfo.getSpid())) {
                vipInfo.setCpid("tencent");
                vipInfo.setSpid("84");
                vipInfo.setActivetype("6");
            } else if ("100611".equals(vipInfo.getSpid())) {
                vipInfo.setCpid("mangtv16");
                vipInfo.setSpid("1006");
                vipInfo.setActivetype("16");
            }
        }
    }

    /**
     * ip校验
     */
    public void checkIp(ActivityLimitConfig config) throws BussinessException {

        ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        HttpServletRequest request = attributes.getRequest();

        if (!StringUtils.isEmpty(config.getLimitip())) {
            log.info("ip============>" + config.getLimitip());
            List<String> list = Arrays.asList(config.getLimitip().split(","));
            log.info("listIP:" + list);
            String ip = IpAddrUtil.getIp(request);
            log.info("ip:" + ip);
            if (!list.contains(ip)) {
                throw new BussinessException("10009", "ip地址校验失败: " + ip);
            }
        }
    }

    public void checkQueryActity(VipInfo vipInfo) throws BussinessException {
        comonService.checkTimestamp(vipInfo.getTimestamp());
        activityService.checkActivity(vipInfo);
        comonService.checkQueryVipSign(vipInfo);
        mobService.checkVipMob(vipInfo);
        if (vipInfo.getCpid().equals("twowei")) {
            if ("10011".equals(vipInfo.getSpid())) {
                vipInfo.setCpid("tencent");
                vipInfo.setSpid("84");
                vipInfo.setActivetype("6");
            } else if ("100611".equals(vipInfo.getSpid())) {
                vipInfo.setCpid("mangtv16");
                vipInfo.setSpid("1006");
                vipInfo.setActivetype("16");
            }
        }
    }

    public void checkChannelQueryActity(VipInfo vipInfo) throws BussinessException {
        comonService.checkTimestamp(vipInfo.getTimestamp());
        activityService.checkActivity(vipInfo);
        comonService.checkChannelQueryVipSign(vipInfo);
        mobService.checkChannelVipMob(vipInfo);
    }

    /**
     * 添加领取会员记录日志
     *
     * @param bean
     */
    public void addJoinActivityLog(JoinActivityLogBean bean) {
        try {
            if (bean != null)
                joinActivityDao.insert(bean);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void giveVip_back20220825(VipInfo activityInfo) throws BussinessException {
        JoinActivityLogBean bean = new JoinActivityLogBean();
        long starttime = System.currentTimeMillis();
        //手动领取spid配置标识
        //Boolean handflag = false;
        try {
            ActivityBean activityBean = activeDao.getActivityInfo(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype());
            if (activityBean == null) {
                OrderInfo orderInfo = preOrdeDao.getOrder(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
                if (orderInfo != null) {
                    throw new BussinessException("9088", "预定购用户不能赠送会员");
                }
                throw new BussinessException("9085", "用户无订购不能赠送会员");
            }

            bean.setProvince(activityBean.getProvince());
            bean.setArea(activityBean.getArea());

            //手动领取会员黑名单校验
            if (!StringUtils.isEmpty(blackList)) {
                List<String> list = Arrays.asList(blackList.split(","));
                if (list != null && list.size() > 0 && list.contains(activityInfo.getSpid())) {
                    if (mangoFreeDao.isActiveTime("begintime") > 0) {

                        System.out.println(list.toString());
                        int blacklistcount = blackListDao.getBlacklistcount(activityInfo.getUserid(), activityInfo.getSpid(), sysDao.getSysTime().substring(0, 6));
                        if (blacklistcount > 0) {
                            throw new BussinessException("9092", "账户异常");
                        }
                        //已领取会员时间的月份与系统时间月份相同
                        if (activityBean.getVipstatus().equals("0")
                                && sysDao.getSysTime().substring(0, 6).equals(activityBean.getViptime().substring(0, 6))) {
                            throw new BussinessException("9087", "会员已领取");
                        }
                    }
                }
            }

            //会员赠送限制
            ecbVipService.queryEcb(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityBean.getProvince(), activityInfo.getType(), activityInfo.getActivetype());

            capKbxkQryService.capKbxkQry(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
            if (activityBean.getOrderstatus().equals("1") && NumberUtils.toLong(activityBean.getEndtime()) < NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"))) {
                throw new BussinessException("9084", "用户为无效订购状态不能赠送会员");
            }
            //查询活动表TD_BUSSINESS_HANDLE，当前是退订状态且结束时间大于当前时间
            //用于处理当月是续送黑名单，但用户当月重新订购后再退订的状态，要能领取会员
            if (activityBean.getOrderstatus().equals("1") && NumberUtils.toLong(activityBean.getEndtime()) >= NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss")) && !activityBean.getOrdertime().substring(0, 6).equals(this.sysDao.getSysTime().substring(0, 6))) {
                //查询续送黑名单表 td_black_official，查询手机号码和SPID是当月是否为黑名单
                int blacklist = this.blackListDao.getBlacklistcount(activityInfo.getUserid(), activityInfo.getSpid(), this.sysDao.getSysTime().substring(0, 6));
                //是黑名单
                if (blacklist > 0) {
                    //查询赠送会员日志表tl_vip_log，是否当月已有领取过会员（续送），如果有则不能再领取
                    int vipCount = this.blackListDao.getVipCount(activityInfo.getUserid(), activityInfo.getActivetype(), activityBean.getOrdertime());
                    if (vipCount > 0) {
                        throw new BussinessException("9092", "账户异常");
                    }
                }
            }

            OrderInfo orderInfo = new OrderInfo();
            orderInfo.setUserid(activityInfo.getUserid());
            orderInfo.setCpid(activityInfo.getCpid());
            orderInfo.setSpid(activityInfo.getSpid());
            OrderInfo order = orderDao.getOrder(orderInfo);
            if (order.getEndtime() != null && !order.getEndtime().equals("")) {
                String today = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
                if (order.getEndtime().compareTo(today) < 0) { //说明结束时间小于系统时间
                    throw new BussinessException("9084", "用户为无效订购状态不能赠送会员!");
                }
            }

            String cangive = giveVipProvinceCrontrolDao.queryProvinceCrontrol(activityInfo.getCpid(), activityInfo.getSpid(), activityBean.getProvince(), activityInfo.getActivetype());
            if (!cangive.equals("0")) {
                throw new BussinessException("9098", "该省份会员被限制领取");
            }
            if (activityBean.getVipstatus().equals("4")) {
                throw new BussinessException("9090", "该活动已暂停赠送会员");
            }
            if (activityBean.getVipstatus().equals("3")) {
                throw new BussinessException("9091", "会员赠送中");
            }
            if (activityBean.getVipstatus().equals("1")) {
                throw new BussinessException("9086", "会员领取失败");
            }
            if (activityBean.getVipstatus().equals("0")) {//会员已领取状态
                //会员已领取状态，验证手动赠送会员
                vailVipJoinSpidConf(activityInfo, activityBean);

                /***
                 if("1016".equals(activityInfo.getSpid())){
                 List<String> list = Arrays.asList(tencentorderChannels.split(","));
                 if(list != null && list.size() > 0){
                 System.out.println(list.toString());
                 OrderInfo orderInfo = new OrderInfo();
                 orderInfo.setUserid(activityInfo.getUserid());
                 orderInfo.setCpid(activityInfo.getCpid());
                 orderInfo.setSpid(activityInfo.getSpid());
                 OrderInfo order = orderDao.getOrder(orderInfo);
                 if(!"".equals(order.getOrderchannel2()) && list.contains(order.getOrderchannel2())){
                 if(sysDao.getSysTime().substring(0, 6).equals(activityBean.getViptime().substring(0,6))){
                 throw new BussinessException("9087", "会员已领取");
                 }
                 System.out.println(order.getOrderchannel2());
                 }else{
                 throw new BussinessException("9087", "会员已领取");
                 }
                 }
                 }else if("1051".equals(activityInfo.getSpid()) || "1052".equals(activityInfo.getSpid())){
                 if(mangoFreeDao.isActiveTime("mangtvtime") > 0){
                 System.out.println("在领取时间范围内");
                 List<String> list = null;
                 if("1051".equals(activityInfo.getSpid())){
                 list = Arrays.asList(mangtv1051orderChannels.split(","));
                 }
                 if("1052".equals(activityInfo.getSpid())){
                 list = Arrays.asList(mangtv1052orderChannels.split(","));
                 }
                 if(list != null && list.size() > 0){
                 System.out.println(list.toString());
                 OrderInfo orderInfo = new OrderInfo();
                 orderInfo.setUserid(activityInfo.getUserid());
                 orderInfo.setCpid(activityInfo.getCpid());
                 orderInfo.setSpid(activityInfo.getSpid());
                 OrderInfo order = orderDao.getOrder(orderInfo);
                 if(!"".equals(order.getOrderchannel2()) && list.contains(order.getOrderchannel2())){
                 if(sysDao.getSysTime().substring(0, 6).equals(activityBean.getViptime().substring(0,6))){
                 throw new BussinessException("9087", "会员已领取");
                 }
                 System.out.println(order.getOrderchannel2());
                 }else{
                 throw new BussinessException("9087", "会员已领取");
                 }
                 }
                 }else{
                 System.out.println("不在领取时间范围内-----");
                 throw new BussinessException("9087", "会员已领取");
                 }
                 }else if(handflag){
                 if(sysDao.getSysTime().substring(0, 6).equals(activityBean.getViptime().substring(0,6))){
                 throw new BussinessException("9087", "会员已领取");
                 }
                 }else{
                 throw new BussinessException("9087", "会员已领取");
                 }
                 ***/
            }
            VipWhiteBean vipWhiteBean = vipWhiteDao.getCount("0", activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
            if (vipWhiteBean == null) {

                //活动代码
                String activetype = activityInfo.getActivetype();
                //CPID
                String cpid = activityInfo.getCpid();
                //SPID
                String spid = activityInfo.getSpid();

                ActivityVipConfigBean config = vipConfigService.getVipConfigBean(activetype, cpid, spid);
                if (config != null) {

                    if ("tencent".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            if ("1016".equals(spid)) {
                                List<String> list = Arrays.asList(tencentorderChannels.split(","));
                                List<String> listBoyuanH5 = Arrays.asList(tencentorderFreeChannels.split(","));
                                List<String> listThree = Arrays.asList(tencent1016ThreeorderChannels.split(","));
                                System.out.println(list.toString());
//								OrderInfo orderInfo = new OrderInfo();
//								orderInfo.setUserid(activityInfo.getUserid());
//								orderInfo.setCpid(cpid);
//								orderInfo.setSpid(spid);
//								OrderInfo order = orderDao.getOrder(orderInfo);
                                System.out.println(order.toString());
                                System.out.println(activityInfo.getUserid());
                                System.out.println(activityBean.getOrdertime());
                                System.out.println(order.getOrderchannel2());
                                if (!"".equals(order.getOrderchannel2()) && list.contains(order.getOrderchannel2())) {
                                    //getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                                    getVipService.give(activityInfo, "00072", "tenc1234");
                                } else if (!"".equals(order.getOrderchannel2()) && listBoyuanH5.contains(order.getOrderchannel2())) {
                                    getVipService.give(activityInfo, "00075", "tenc1234");
                                } else if (!"".equals(order.getOrderchannel2()) && listThree.contains(order.getOrderchannel2())) {
                                    getVipService.give(activityInfo, "00063", "tenc1234");
                                } else {
                                    if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getOrdertime().substring(0, 6))) {
                                        getVipService.give(activityInfo, "00061", "tenc1234");
                                    } else {
                                        getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                                    }
                                }
                            } else if ("1047".equals(spid)) {
                                if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getOrdertime().substring(0, 6))) {
                                    getVipService.give(activityInfo, "00060", "tenc1234");
                                } else {
                                    getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                                }
                            } else if ("1244".equals(spid)) {  //特有渠道使用会员池
                                List<String> list1244 = Arrays.asList(tencent1244orderChannels.split(","));
                                if (!"".equals(order.getOrderchannel2()) && list1244.contains(order.getOrderchannel2())) {
                                    getVipService.give(activityInfo, "27714", "tenc1234");
                                } else {  //默认会员此
                                    getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                                }
                            } else {
                                getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                            }
                        } else {
                            giveVipService.give(activityInfo);
                        }

                    } else if ("cctv".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            try {
                                ctvGiveVipService.give(activityInfo);
                            } catch (Exception e) {
                                activityBean.setVipstatus("1");
                                activeDao.updateVip(activityBean);
                                throw e;
                            }
                        }

                    } else if ("aiqy".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            String vipid = "00027";
                            String vipidpwd = "aiqy2017";
                            if ("1011".equals(spid) || "1012".equals(spid)) {
                                System.out.println(sysDao.getSysTime().substring(0, 6));
                                System.out.println(activityBean.getOrdertime().substring(0, 6));
                                if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getOrdertime().substring(0, 6))) {
                                    getVipService.give(activityInfo, vipid, vipidpwd);
                                } else {
                                    getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                                }
                            } else {
                                getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                            }

                        } else {
                            if (activityInfo.getActivetype().equals("18")) {
                                aiqiyiGiveMonthVipService.give(activityInfo);
                            } else if ((activityInfo.getActivetype().equals("20"))) {
                                aiqiyiGiveMonthVipService.give(activityInfo);
                            } else {
                                aiqiyiGiveVipService.give(activityInfo);
                            }
                        }

                    } else if ("leshilt".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            if ("newIntfc".equals(activityInfo.getExt()))
                                leshiNewGiveVipService.give(activityInfo);
                            else
                                leshiGiveVipService.give(activityInfo);
                        }

                    } else if ("mangtv16".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            String activetypeFree = "00017";
                            String vipid = "00017";
                            String vippwd = "mang1234";

                            boolean flagfree = false;
                            int i = mangoFreeDao.isActiveTime(activetypeFree);//判断订购是否在活动期
                            if (i > 0) {
                                int j = mangoFreeDao.isActiveOrder(activityInfo.getUserid(), activetypeFree);//判断订购是事在活动期
                                if (j > 0) {
                                    int k = mangoFreeDao.isGetFree(activityInfo.getUserid(), vipid);//判断是不是已经领取了免费的
                                    if (k == 0) {
                                        flagfree = true;
                                    }
                                }
                            }

                            if (flagfree) {
                                getVipService.giveMangoFree(activityInfo, vipid, vippwd);
                            } else {
                                getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                            }

                        } else {
                            mangtvGiveVipService.give(activityInfo);
                            //mangtvFreeVipService.give(activityInfo);
                        }

                    } else if ("youtu".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {

                            if ("yksyt".equals(activityInfo.getChannel()) && "1167".equals(spid)) {
                                getVipService.give(activityInfo, "00026", "youtu123");
                            } else if (("1167".equals(spid) || "1058".equals(spid)) && (!"".equals(order.getOrderchannel()) && order.getOrderchannel().equals("200000000036"))) {
                                getVipService.give(activityInfo, "00026", "youtu123");
                            } else if ("1048".equals(spid)) {
                                if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getOrdertime().substring(0, 6))) {
                                    getVipService.give(activityInfo, "00029", "youtu2021");
                                } else {
                                    getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                                }
                            } else {
                                getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                            }
                        } else {
                            youku20VipService.giveVip(activityInfo);
                        }

                    } else if ("pptv".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            pptvGiveVipService.giveVip(activityInfo);
                        }

                    } else if ("huashuapp".equals(activityInfo.getCpid())) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            wasuVipService.giveVip(activityInfo);
                        }

                    } else if ("fengx".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            fengx12VipService.giveVip(activityInfo);
                        }

                    } else if ("sohutv".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            getVipService.give(activityInfo, "00043", "shy72dh3");
                        }

                    } else if ("xueguoxue".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            getVipService.give(activityInfo, "00045", "xgx02ml5");
                        }
                    } else if ("bilibl".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else if ("ppsport".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }

                    } else if ("changshi".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else if ("yangshipin".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else if ("keep".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else {
                        throw new BussinessException("9088", "该cp暂未开放");
                    }
                } else {
                    throw new BussinessException("9109", "会员领取配置异常");
                }
            } else if (vipWhiteBean.getType().equals("1")) {
                throw new BussinessException("9089", "黑名单用户禁止领取");
            }

            bean.setErrorcode("0");
            bean.setErrorinfo("成功");

            System.out.println("activityBean=" + JSON.toJSONString(activityBean));
            System.out.println("VipInfo=" + JSON.toJSONString(activityInfo));
            activityBean.setVipstatus("0");
            activeDao.updateVip(activityBean);
            userMsgDao.insertMsg(getUserMsgBean(activityInfo));
        } catch (Exception e) {
            if (e instanceof BussinessException) {
                bean.setErrorcode(((BussinessException) e).getCode());
                bean.setErrorinfo(((BussinessException) e).getMessage());
                throw e;
            } else {
                bean.setErrorcode("8000");
                bean.setErrorinfo(e.getMessage());
                throw e;
            }
        } finally {
            bean.setUserid(activityInfo.getUserid());
            bean.setCpid(activityInfo.getCpid());
            bean.setSpid(activityInfo.getSpid());
            bean.setActivetype(activityInfo.getActivetype());
            bean.setJointype(activityInfo.getType() + "");
            bean.setUsertype(activityInfo.getUsertype());
            bean.setUserval(activityInfo.getUserval());
            bean.setChannel(activityInfo.getChannel());
            bean.setVippool(activityInfo.getVippool());
            long endtime = System.currentTimeMillis();
            long times = (endtime - starttime) / 1000;
            bean.setTimes(times + "");
            this.addJoinActivityLog(bean);
        }
    }


    public UserMsgBean getUserMsgBean(VipInfo activityInfo) {
        UserMsgBean userMsgBean = new UserMsgBean();
        userMsgBean.setActiveid(activityInfo.getActivetype());
        userMsgBean.setCpid(activityInfo.getCpid());
        userMsgBean.setMsg1(activityInfo.getUserval());
        userMsgBean.setMsg2(activityInfo.getUsertype());
        userMsgBean.setMsg3(activityInfo.getVipname() == null ? "" : activityInfo.getVipname());
        userMsgBean.setSpid(activityInfo.getSpid());
        userMsgBean.setUserid(activityInfo.getUserid());
        System.out.println("UserMsgBean=" + JSON.toJSONString(activityInfo));
        return userMsgBean;
    }


    public void giveVip(VipInfo activityInfo) throws BussinessException {
        JoinActivityLogBean bean = new JoinActivityLogBean();
        long starttime = System.currentTimeMillis();
        //手动领取spid配置标识
        //Boolean handflag = false;
        try {
            ActivityBean activityBean = activeDao.getActivityInfo(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype());
            if (activityBean == null) {
                OrderInfo orderInfo = preOrdeDao.getOrder(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
                if (orderInfo != null) {
                    throw new BussinessException("9088", "预定购用户不能赠送会员");
                }
                throw new BussinessException("9085", "用户无订购不能赠送会员");
            }

            bean.setProvince(activityBean.getProvince());
            bean.setArea(activityBean.getArea());

            //手动领取会员黑名单校验
            if (!StringUtils.isEmpty(blackList)) {
                List<String> list = Arrays.asList(blackList.split(","));
                if (list != null && list.size() > 0 && list.contains(activityInfo.getSpid())) {
                    if (mangoFreeDao.isActiveTime("begintime") > 0) {

                        System.out.println(list.toString());
                        int blacklistcount = blackListDao.getBlacklistcount(activityInfo.getUserid(), activityInfo.getSpid(), sysDao.getSysTime().substring(0, 6));
                        if (blacklistcount > 0) {
                            throw new BussinessException("9092", "账户异常");
                        }
                        //已领取会员时间的月份与系统时间月份相同
                        if (activityBean.getVipstatus().equals("0")
                                && sysDao.getSysTime().substring(0, 6).equals(activityBean.getViptime().substring(0, 6))) {
                            throw new BussinessException("9087", "会员已领取");
                        }
                    }
                }
            }

            //会员赠送限制
            ecbVipService.queryEcb(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityBean.getProvince(), activityInfo.getType(), activityInfo.getActivetype());

            capKbxkQryService.capKbxkQry(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
            if (activityBean.getOrderstatus().equals("1") && NumberUtils.toLong(activityBean.getEndtime()) < NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"))) {
                throw new BussinessException("9084", "用户为无效订购状态不能赠送会员");
            }
            //查询活动表TD_BUSSINESS_HANDLE，当前是退订状态且结束时间大于当前时间
            //用于处理当月是续送黑名单，但用户当月重新订购后再退订的状态，要能领取会员
            if (activityBean.getOrderstatus().equals("1") && NumberUtils.toLong(activityBean.getEndtime()) >= NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss")) && !activityBean.getOrdertime().substring(0, 6).equals(this.sysDao.getSysTime().substring(0, 6))) {
                //查询续送黑名单表 td_black_official，查询手机号码和SPID是当月是否为黑名单
                int blacklist = this.blackListDao.getBlacklistcount(activityInfo.getUserid(), activityInfo.getSpid(), this.sysDao.getSysTime().substring(0, 6));
                //是黑名单
                if (blacklist > 0) {
                    //查询赠送会员日志表tl_vip_log，是否当月已有领取过会员（续送），如果有则不能再领取
                    int vipCount = this.blackListDao.getVipCount(activityInfo.getUserid(), activityInfo.getActivetype(), activityBean.getOrdertime());
                    if (vipCount > 0) {
                        throw new BussinessException("9092", "账户异常");
                    }
                }
            }

            OrderInfo orderInfo = new OrderInfo();
            orderInfo.setUserid(activityInfo.getUserid());
            orderInfo.setCpid(activityInfo.getCpid());
            orderInfo.setSpid(activityInfo.getSpid());
            OrderInfo order = orderDao.getOrder(orderInfo);
            if (order.getEndtime() != null && !order.getEndtime().equals("")) {
                String today = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
                if (order.getEndtime().compareTo(today) < 0) { //说明结束时间小于系统时间
                    throw new BussinessException("9084", "用户为无效订购状态不能赠送会员!");
                }
            }

            String cangive = giveVipProvinceCrontrolDao.queryProvinceCrontrol(activityInfo.getCpid(), activityInfo.getSpid(), activityBean.getProvince(), activityInfo.getActivetype());
            if (!cangive.equals("0")) {
                throw new BussinessException("9098", "该省份会员被限制领取");
            }
            if (activityBean.getVipstatus().equals("4")) {
                throw new BussinessException("9090", "该活动已暂停赠送会员");
            }
            if (activityBean.getVipstatus().equals("3")) {
                throw new BussinessException("9091", "会员赠送中");
            }
            if (activityBean.getVipstatus().equals("1")) {
                throw new BussinessException("9086", "会员领取失败");
            }
            if (activityBean.getVipstatus().equals("990099")) {
                throw new BussinessException("9091", "会员赠送中");
            }
            if (activityBean.getVipstatus().equals("0")) {//会员已领取状态
                //会员已领取状态，验证手动赠送会员
                vailVipJoinSpidConf(activityInfo, activityBean);

            }
            VipWhiteBean vipWhiteBean = vipWhiteDao.getCount("0", activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid());
            if (vipWhiteBean == null) {

                //活动代码
                String activetype = activityInfo.getActivetype();
                //CPID
                String cpid = activityInfo.getCpid();
                //SPID
                String spid = activityInfo.getSpid();

                ActivityVipConfigBean config = vipConfigService.getVipConfigBean(activetype, cpid, spid);
                if (config != null) {

                    if ("tencent".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            giveVipService.give(activityInfo);
                        }

                    } else if ("cctv".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            try {
                                ctvGiveVipService.give(activityInfo);
                            } catch (Exception e) {
                                activityBean.setVipstatus("1");
                                activeDao.updateVip(activityBean);
                                throw e;
                            }
                        }

                    } else if ("aiqy".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            if (activityInfo.getActivetype().equals("18")) {
                                aiqiyiGiveMonthVipService.give(activityInfo);
                            } else if ((activityInfo.getActivetype().equals("20"))) {
                                aiqiyiGiveMonthVipService.give(activityInfo);
                            } else {
                                aiqiyiGiveVipService.give(activityInfo);
                            }
                        }

                    } else if ("leshilt".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            if ("newIntfc".equals(activityInfo.getExt()))
                                leshiNewGiveVipService.give(activityInfo);
                            else
                                leshiGiveVipService.give(activityInfo);
                        }

                    } else if ("mangtv16".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            String activetypeFree = "00017";
                            String vipid = "00017";
                            String vippwd = "mang1234";

                            boolean flagfree = false;
                            int i = mangoFreeDao.isActiveTime(activetypeFree);//判断订购是否在活动期
                            if (i > 0) {
                                int j = mangoFreeDao.isActiveOrder(activityInfo.getUserid(), activetypeFree);//判断订购是事在活动期
                                if (j > 0) {
                                    int k = mangoFreeDao.isGetFree(activityInfo.getUserid(), vipid);//判断是不是已经领取了免费的
                                    if (k == 0) {
                                        flagfree = true;
                                    }
                                }
                            }

                            if (flagfree) {
                                getVipService.giveMangoFree(activityInfo, vipid, vippwd);
                            } else {
                                receiveJoin(activityInfo, config, order, activityBean);
                            }

                        } else {
                            mangtvGiveVipService.give(activityInfo);
                            //mangtvFreeVipService.give(activityInfo);
                        }

                    } else if ("youtu".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            if ("yksyt".equals(activityInfo.getChannel()) && "1167".equals(spid)) {
                                getVipService.give(activityInfo, "00026", "youtu123");
                            } else {
                                receiveJoin(activityInfo, config, order, activityBean);
                            }
                        } else {
                            youku20VipService.giveVip(activityInfo);
                        }

                    } else if ("pptv".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            pptvGiveVipService.giveVip(activityInfo);
                        }

                    } else if ("huashuapp".equals(activityInfo.getCpid())) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            wasuVipService.giveVip(activityInfo);
                        }

                    } else if ("fengx".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            fengx12VipService.giveVip(activityInfo);
                        }

                    } else if ("sohutv".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            getVipService.give(activityInfo, "00043", "shy72dh3");
                        }

                    } else if ("xueguoxue".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            getVipService.give(activityInfo, "00045", "xgx02ml5");
                        }
                    } else if ("bilibl".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else if ("ppsport".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else if ("changshi".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            if ("1217".equals(spid)) { // keep异步
                                receiveJoinAsyn(activityInfo, config, order, activityBean);
                            } else {
                                receiveJoin(activityInfo, config, order, activityBean);
                            }
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else if ("yangshipin".equals(cpid)) {
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoin(activityInfo, config, order, activityBean);
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else if ("keep".equals(cpid)) {  //异步接口
                        if (StrUtil.isNotBlank(config.getVipid(), config.getVippwd())) {
                            receiveJoinAsyn(activityInfo, config, order, activityBean);
                        } else {
                            throw new BussinessException("9109", "会员领取配置异常");
                        }
                    } else {
                        throw new BussinessException("9088", "该cp暂未开放");
                    }
                } else {
                    throw new BussinessException("9109", "会员领取配置异常");
                }
            } else if (vipWhiteBean.getType().equals("1")) {
                throw new BussinessException("9089", "黑名单用户禁止领取");
            }

            bean.setErrorcode("0");
            bean.setErrorinfo("成功");

            activityBean.setVipstatus("0");
            activeDao.updateVip(activityBean);
            userMsgDao.insertMsg(getUserMsgBean(activityInfo));
            log.info("VipInfo=" + JSON.toJSONString(activityInfo));
            log.info("activityBean=" + JSON.toJSONString(activityBean));
        } catch (Exception e) {
            if (e instanceof BussinessException) {
                bean.setErrorcode(((BussinessException) e).getCode());
                bean.setErrorinfo(((BussinessException) e).getMessage());
                throw e;
            } else {
                bean.setErrorcode("8000");
                bean.setErrorinfo(e.getMessage());
                throw e;
            }
        } finally {
            bean.setUserid(activityInfo.getUserid());
            bean.setCpid(activityInfo.getCpid());
            bean.setSpid(activityInfo.getSpid());
            bean.setActivetype(activityInfo.getActivetype());
            bean.setJointype(activityInfo.getType() + "");
            bean.setUsertype(activityInfo.getUsertype());
            bean.setUserval(activityInfo.getUserval());
            bean.setChannel(activityInfo.getChannel());
            bean.setVippool(activityInfo.getVippool());
            long endtime = System.currentTimeMillis();
            long times = (endtime - starttime) / 1000;
            bean.setTimes(times + "");
            this.addJoinActivityLog(bean);
        }
    }

    public void queryVip(VipInfo activityInfo) throws BussinessException {
        ActivityBean activityBean = activeDao.getActivityInfo(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype());
        if (activityBean == null) {
            throw new BussinessException("9081", "用户无订购不能赠送会员");
        }
        if (activityBean.getOrderstatus().equals("1") && NumberUtils.toLong(activityBean.getEndtime()) < NumberUtils.toLong(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"))) {
            throw new BussinessException("9084", "用户为无效订购状态不能赠送会员");
        }
        if (activityBean.getVipstatus().equals("2")) {
            throw new BussinessException("9083", "可赠送会员，用户未领取");
        }
        if (activityBean.getVipstatus().equals("1")) {
            throw new BussinessException("9082", "会员赠送失败");
        }
        if (activityBean.getVipstatus().equals("4")) {
            throw new BussinessException("9090", "该活动已暂停赠送会员");
        }
        if (activityBean.getVipstatus().equals("3")) {
            throw new BussinessException("9091", "会员赠送中");
        }
        if (activityBean.getVipstatus().equals("990099")) {
            throw new BussinessException("9091", "会员赠送中");
        }
        UserMsgBean userMsgBean = userMsgDao.getMsg(activityInfo.getUserid(), activityInfo.getCpid(), activityInfo.getSpid(), activityInfo.getActivetype());
        if (userMsgBean != null) {
            activityInfo.setUsertype(userMsgBean.getMsg2());
            activityInfo.setUserval(userMsgBean.getMsg1());
            activityInfo.setVipname(userMsgBean.getMsg3());
        }
    }

    public List<QueryVipLogOutPipe> queryVipLog(VipInfo activityInfo) throws BussinessException {
        return vipdao.query(activityInfo.getUserid(), activityInfo.getActivetype());
    }

    /**
     * 当活动表的会员领取状态为已领取时，判断是否当月还能再手动领取会员
     *
     * @return
     * @throws Exception
     */
    public void vailVipJoinSpidConf(VipInfo activityInfo, ActivityBean activityBean) throws BussinessException {
        try {
            boolean contains = false;
            String spid = activityInfo.getSpid();
            //获取手动赠送配置表的信息
            List<HashMap> dataList = vipJoinSpidDao.getVipJoinSpidConf(spid);
            if (dataList != null && dataList.size() > 0) {
                //获取活动表的订购信息
                OrderInfo orderInfo = new OrderInfo();
                orderInfo.setUserid(activityInfo.getUserid());
                orderInfo.setCpid(activityInfo.getCpid());
                orderInfo.setSpid(activityInfo.getSpid());
                //查询订购关系表获取订购信息
                OrderInfo order = orderDao.getOrder(orderInfo);
                if (order == null) {
                    throw new BussinessException("9085", "用户无订购不能赠送会员");
                }
                //获取子渠道
                String orderchannel2 = order.getOrderchannel2();
                //获取主渠道
                String orderchannel = order.getOrderchannel();
                log.info("手动领取会员配置：" + dataList + "，orderchannel2=>" + orderchannel2 + "，orderchannel=>" + orderchannel + "，userid=>" + activityInfo.getUserid() + "，spid=>" + activityInfo.getSpid());
                //子渠道标识或主渠道标识不为空
                if (!StringUtils.isEmpty(orderchannel2) || !StringUtils.isEmpty(orderchannel)) {
                    //渠道是否有配置
                    for (HashMap hm : dataList) {
                        if ("0".equals(hm.get("HASSUBCHANNEL"))) {//子渠道
                            //配置渠道与子渠道相同，SPID相同，当前月份与已领取月份不相同
                            if (!StringUtils.isEmpty(orderchannel2)
                                    && (orderchannel2.equals(hm.get("CHANNEL")))
                                    && spid.equals(hm.get("SPID"))
                                    && this.valiConfDate(activityInfo, activityBean, hm)) {
                                contains = true;
                                break;
                            }
                        } else {//主渠道
                            //配置渠道为 * ，SPID相同，当前月份与已领取月份不相同
                            if (!StringUtils.isEmpty(orderchannel)
                                    && ("*".equals(hm.get("CHANNEL")))
                                    && spid.equals(hm.get("SPID"))
                                    && this.valiConfDate(activityInfo, activityBean, hm)) {
                                /*
                                 * 修改新逻辑
                                 * 11.1之前订购的不变
                                 * 1011,1012,1016,1047,1048,1049,1051,1052（根据业务变化）
                                 * 11.1之后订购的，除部分产品的几个特殊渠道，以上spid由续送改为手动领取
                                 * */
                                String time = "20221101000000";
                                final long time_long = Long.parseLong(time);
                                final long ordertime_long = Long.parseLong(order.getOrdertime());
                                if (!StringUtils.isEmpty(order.getOrdertime())) {
                                    String contractspids = dictionaryDao.getValue("contractspids");
                                    if (!StringUtils.isEmpty(contractspids) && contractspids.contains(spid)) {
                                        if (ordertime_long >= time_long) {
                                            /*if ("1016".equals(spid)) {
                                                // 特殊的渠道自动送，展示已领取   false
                                                String specialchannels = dictionaryDao.getValue("specialchannels");
                                                if (!StringUtils.isEmpty(specialchannels) && specialchannels.contains(orderchannel2)) {
                                                    log.info("该产品为特殊渠道" + spid + "=======>" + orderchannel2);
                                                } else {
                                                    contains = true;
                                                }
                                            } else {
                                                contains = true;
                                            }*/

                                            // 特殊的渠道自动送，展示已领取   false
                                            String specialchannels = dictionaryDao.getValue("specialchannels_" + spid);
                                            if (!StringUtils.isEmpty(specialchannels)) {
                                                if (specialchannels.contains(orderchannel2)) {
                                                    log.info("该产品渠道为需续送的特殊渠道" + spid + "=======>" + orderchannel2);
                                                } else {
                                                    contains = true;
                                                }
                                            } else {
                                                contains = true;
                                            }

                                        } else {
                                            continue;
                                        }
                                    } else {
                                        contains = true;
                                    }
                                } else {
                                    log.info("该数据无订购关系" + activityInfo.getUserid() + "=====>" + spid);
                                }

/*
								// 特殊的渠道不允许手动领取
								String specialchannels = dictionaryDao.getValue("specialchannels");
								if (!StringUtils.isEmpty(specialchannels) && specialchannels.contains(orderchannel2)){
									log.info("该产品为特殊渠道" + spid + "=======>" + orderchannel2);
								}else {
									contains = true;
								}*/
                                break;
                            }else if (!StringUtils.isEmpty(orderchannel)
                                    && orderchannel.equals(hm.get("CHANNEL"))
                                    && spid.equals(hm.get("SPID"))
                                    && this.valiConfDate(activityInfo, activityBean, hm)){
                                //配置渠道与主渠道相同，SPID相同，当前月份与已领取月份不相同
                                contains = true;
                                break;
                            }
                        }

                    }
                } else {//orderchannel和orderchannel2都为空
                    //渠道是否有配置
                    for (HashMap hm : dataList) {
                        //配置渠道与主渠道相同，SPID相同，当前月份与已领取月份不相同
                        if ("*".equals(hm.get("CHANNEL"))
                                && spid.equals(hm.get("SPID"))
                                && this.valiConfDate(activityInfo, activityBean, hm)) {
                            contains = true;
                            break;
                        }
                    }
                }
            }

            if (!contains) {
                throw new BussinessException("9087", "会员已领取");
            }
        } catch (Exception e) {
            if (e instanceof BussinessException) {
                throw e;
            } else {
                throw new BussinessException("8000", "验证手动赠送会员出现异常，" + e.getMessage());
            }
        }
    }

    /**
     * 验证业务是否在配置时间内
     *
     * @param confmap      手动领取会员配置
     * @param activityBean viptime 已领取会员时间
     * @return
     */
    private boolean valiConfDate(VipInfo activityInfo, ActivityBean activityBean, HashMap confmap) {
        boolean res = false;
        String starttime = null;
        String endtime = null;
        String systime = sysDao.getSysTime();
        String viptime = activityBean.getViptime();
        String userid = activityInfo.getUserid();
        String spid = activityInfo.getSpid();

        //判断当月是否已领取过会员（系统时间的月份与已领取时间的月份相同）
        if (!StringUtils.isEmpty(viptime) && systime.substring(0, 6).equals(viptime.substring(0, 6))) {
            log.info("userid=>" + userid + "，spid=>" + spid + "，当月已领取，systime=>" + systime + "，viptime=>" + viptime);
            return res;
        }

        //判断开始时间和结束时间是否合法
        if (confmap.get("STARTTIME") != null && confmap.get("STARTTIME").toString().length() == 14) {
            starttime = confmap.get("STARTTIME").toString();
        }
        if (confmap.get("ENDTIME") != null && confmap.get("ENDTIME").toString().length() == 14) {
            endtime = confmap.get("ENDTIME").toString();
        }

        //有时间配置
        if (!StringUtils.isEmpty(starttime) || !StringUtils.isEmpty(endtime)) {
            //开始时间和结束时间都有配置
            if (!StringUtils.isEmpty(starttime) && !StringUtils.isEmpty(endtime)
                    && Long.parseLong(systime) >= Long.parseLong(starttime)
                    && Long.parseLong(systime) <= Long.parseLong(endtime)) {
                res = true;
                //只配置了开始时间
            } else if (!StringUtils.isEmpty(starttime) && StringUtils.isEmpty(endtime)
                    && Long.parseLong(systime) >= Long.parseLong(starttime)) {
                res = true;
                //只配置了结束时间
            } else if (StringUtils.isEmpty(starttime) && !StringUtils.isEmpty(endtime)
                    && Long.parseLong(systime) <= Long.parseLong(endtime)) {
                res = true;
            }
        } else { //时间无配置
            res = true;
        }

        log.info("userid=>" + userid + "，spid=>" + spid + "，手动领取时间验证结果=>" + res + "，systime=>" + systime + "，starttime=>" + starttime + "，endtime=>" + endtime + "，viptime=>" + viptime);

        return res;
    }


    /**
     * 会员公共领取方法
     *
     * @return
     * @throws Exception
     */
    public void receiveJoin(VipInfo activityInfo, ActivityVipConfigBean config, OrderInfo order, ActivityBean activityBean) throws BussinessException {
        boolean contains = false;
        String spid = activityInfo.getSpid();
        String vipid = "";
        String vippwd = "";
        //获取手动赠送配置表的信息
        List<HashMap> dataList = vipReceiveDao.getVipReceiveConf(spid);
        if (dataList != null && dataList.size() > 0) {
            //获取子渠道
            String orderchannel2 = order.getOrderchannel2();
            //获取主渠道
            String orderchannel = order.getOrderchannel();

            log.info("单产品领取会员配置：" + dataList + "，orderchannel2=>" + orderchannel2 + "，orderchannel=>" + orderchannel + "，userid=>" + activityInfo.getUserid() + "，spid=>" + activityInfo.getSpid());

            for (HashMap hm : dataList) {
                vipid = (String) hm.get("VIPID");
                vippwd = (String) hm.get("VIPPWD");
                if ("0".equals(hm.get("HASSUBCHANNEL"))) {//子渠道
                    if (!StringUtils.isEmpty(orderchannel2) && orderchannel2.equals(hm.get("CHANNEL")) && spid.equals(hm.get("SPID"))) {
                        contains = true;
                        break;
                    }
                } else if ("1".equals(hm.get("HASSUBCHANNEL"))) { //主渠道
                    if (!StringUtils.isEmpty(orderchannel) && orderchannel.equals(hm.get("CHANNEL")) && spid.equals(hm.get("SPID"))) {
                        contains = true;
                        break;
                    }
                } else if ("2".equals(hm.get("HASSUBCHANNEL")) && "sysdate".equals(hm.get("CHANNEL"))) { //时间比较
                    if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getOrdertime().substring(0, 6))) {
                        contains = true;
                        break;
                    }
                } else {
                    contains = true;
                    break;
                }
            }
        }

        if (contains) {  //走特殊配置
            getVipService.give(activityInfo, vipid, vippwd);
        } else { //走默认配置
            getVipService.give(activityInfo, config.getVipid(), config.getVippwd());
        }

    }

    /**
     * 异步领取、续送
     * 增加账期补送
     *
     * @param vipLog
     * @throws BussinessException
     */
    public void asyncGiveVip(VipLogBean vipLog) throws BussinessException {
        log.info("vipog ：" + JSON.toJSONString(vipLog));
        // 区分单产品和多产品  通过Activitytype，判断fhspid是否为空
        ActivityBean activityBean = null;
        try {
            VipAccountBean vipAccount = activeDao.getAccount(vipLog.getRequestid());

            if (vipAccount == null) {
                log.info("当前账期无数据" + vipLog.getUserid() + "====" + vipLog.getActivitytype() + "====" + vipLog.getRequestid());
            } else {
                // 补送
                if ("3".equals(vipAccount.getViptype())) {
                    if ("0".equals(vipLog.getResultcode())) {
                        vipAccount.setVipstatus("0");
                        complementSendDao.updateAccount(vipAccount);
                        //  td_vipgive_control 根据账期月份新增数据
                        vipGiveDao.saveVipGiveByMonth(vipAccount.getUserid(), vipAccount.getCpid(), vipAccount.getSpid(), vipAccount.getActivitytype(), vipAccount.getMonthtime());
                    } else {
                        vipAccount.setResultcode(vipLog.getResultcode());
                        vipAccount.setErrorinfo(vipLog.getErrorinfo());
                        complementSendDao.updateReplace(vipAccount);  // 补送失败的恢复为未领取
                    }
                    return;
                }
            }

            activityBean = activeDao.getActivity(vipLog.getRequestid());
            if (activityBean == null) {
                throw new BussinessException("9085", "用户无订购不能赠送会员");
            }
            vipLog.setCpid(activityBean.getCpid());
            vipLog.setSpid(activityBean.getSpid());
            log.info("领取/1续送 ： " + vipLog.getType());
            // 0 领取  1 续送
            Integer type = 1;
            if (type.equals(vipLog.getType())) {
                if ("0".equals(vipLog.getResultcode())) {
                    // 续送成功
                    if (vipAccount != null) {
                        vipAccount.setVipstatus("0");
                        complementSendDao.updateAccount(vipAccount);
                    }
                    activityBean.setVipconstatus("0");
                    //	新增td_vipgive_control
                    vipGiveDao.insertVipGiveInfo(vipLog.getUserid(), activityBean.getCpid(), activityBean.getSpid(), "", vipLog.getActivitytype());
                } else {
                    // 续送失败
                    if (vipAccount != null) {
                        vipAccount.setResultcode(vipLog.getResultcode());
                        vipAccount.setErrorinfo(vipLog.getErrorinfo());
                        complementSendDao.updateReplace(vipAccount);  // 补送失败的恢复为未领取
                    }
                    activityBean.setVipconstatus("1");
                }
                activeDao.updateContimueVipStatus(activityBean); // 改活动关系表

                // 改续送表 TL_CONTINUEORDER_LOG（vipresultcode,viperrorinfo）
                if (StringUtils.isEmpty(activityBean.getFhspid())) {
                    // 单产品
                    activeDao.updateContinueOrder(vipLog);
                } else {
                    // 复合产品的子产品
                    activeDao.updateContinueOrderWithFh(vipLog);
                }
            } else {
                if ("0".equals(vipLog.getResultcode())) {
                    //   补送只修改账期以及新增td_vipgive_control    领取还需要修改活动关系表等
                    if (vipAccount != null) {
                        vipAccount.setVipstatus("0");
                        complementSendDao.updateAccount(vipAccount);
                    } else {
                        log.info("当前账期无数据" + vipLog.getUserid() + "====" + activityBean.getSpid() + "====" + vipLog.getRequestid());
                    }

                    // 领取
                    //  1：更新活动关系表 vipstatus=0 TD_BUSSINESS_HANDLE
                    activityBean.setVipstatus("0");
                    //	2：新增td_usermsg_info
                    saveUserMsg(vipLog);
                    //	新增td_vipgive_control
                    vipGiveDao.insertVipGiveInfo(vipLog.getUserid(), activityBean.getCpid(), activityBean.getSpid(), "", vipLog.getActivitytype());
                    activeDao.updateVipStatus(activityBean);
                    VipInfo vipInfo = new VipInfo();
                    BeanUtils.copyProperties(vipLog, vipInfo);
                    vipInfo.setActivetype(vipLog.getActivitytype());
                    log.info("vipInfo : " + JSON.toJSONString(vipInfo));
                    // 领取成功推队列发短信（根据activitytype）
                    activity.inserSmstMq(vipInfo);

                } else {
                    if (vipAccount != null) {
                        vipAccount.setResultcode(vipLog.getResultcode());
                        vipAccount.setErrorinfo(vipLog.getErrorinfo());
                        complementSendDao.updateReplace(vipAccount);  // 补送失败的恢复为未领取
                    }
                    // 更新活动关系表 vipstatus 失败
                    activityBean.setVipstatus("1");
                    activeDao.updateVipStatus(activityBean);

                }
            }
            if (StringUtils.isEmpty(activityBean.getFhspid())) {
                redisService.removeKey("vip_" + activityBean.getCpid() + "_" + activityBean.getSpid() + "_" + vipLog.getUserid());
            } else {
                redisService.removeKey("vip_" + activityBean.getFhcpid() + "_" + activityBean.getFhspid() + "_" + vipLog.getUserid());
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.info("activityBean: " + activityBean);
            log.info("会员异步处理更新数据失败" + e.getMessage() + e);
            throw e;
        }
    }

    private void saveUserMsg(VipLogBean vipLog) {
        UserMsgBean userMsgBean = new UserMsgBean();
        userMsgBean.setActiveid(vipLog.getActivitytype());
        userMsgBean.setCpid(vipLog.getCpid());
        userMsgBean.setMsg1(vipLog.getUserval());
        userMsgBean.setMsg2(vipLog.getUsertype());
        userMsgBean.setMsg3(vipLog.getVipname() == null ? "" : vipLog.getVipname());
        userMsgBean.setSpid(vipLog.getSpid());
        userMsgBean.setUserid(vipLog.getUserid());
        log.info("UserMsgBean : " + JSON.toJSONString(userMsgBean));
        userMsgDao.insertMsg(userMsgBean);
    }

    /**
     * 会员公共领取方法(会员领取新增异步流程20220921)
     *
     * @return
     * @throws Exception
     */
    public void receiveJoinAsyn(VipInfo activityInfo, ActivityVipConfigBean config, OrderInfo order, ActivityBean activityBean) throws BussinessException {
        boolean contains = false;
        String spid = activityInfo.getSpid();
        String vipid = "";
        String vippwd = "";
        //获取手动赠送配置表的信息
        List<HashMap> dataList = vipReceiveDao.getVipReceiveConf(spid);
        if (dataList != null && dataList.size() > 0) {
            //获取子渠道
            String orderchannel2 = order.getOrderchannel2();
            //获取主渠道
            String orderchannel = order.getOrderchannel();

            log.info("单产品领取会员配置：" + dataList + "，orderchannel2=>" + orderchannel2 + "，orderchannel=>" + orderchannel + "，userid=>" + activityInfo.getUserid() + "，spid=>" + activityInfo.getSpid());

            for (HashMap hm : dataList) {
                vipid = (String) hm.get("VIPID");
                vippwd = (String) hm.get("VIPPWD");
                if ("0".equals(hm.get("HASSUBCHANNEL"))) {//子渠道
                    if (!StringUtils.isEmpty(orderchannel2) && orderchannel2.equals(hm.get("CHANNEL")) && spid.equals(hm.get("SPID"))) {
                        contains = true;
                        break;
                    }
                } else if ("1".equals(hm.get("HASSUBCHANNEL"))) { //主渠道
                    if (!StringUtils.isEmpty(orderchannel) && orderchannel.equals(hm.get("CHANNEL")) && spid.equals(hm.get("SPID"))) {
                        contains = true;
                        break;
                    }
                } else if ("2".equals(hm.get("HASSUBCHANNEL")) && "sysdate".equals(hm.get("CHANNEL"))) { //时间比较
                    if (sysDao.getSysTime().substring(0, 6).equals(activityBean.getOrdertime().substring(0, 6))) {
                        contains = true;
                        break;
                    }
                } else {
                    contains = true;
                    break;
                }
            }
        }

        if (contains) {  //走特殊配置
            getVipService.giveAsyn(activityInfo, vipid, vippwd, activityBean);
        } else { //走默认配置
            getVipService.giveAsyn(activityInfo, config.getVipid(), config.getVippwd(), activityBean);
        }

    }

}
