package com.chinacreator.video.service.handle;


import java.text.SimpleDateFormat;
import java.util.Date;

import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.VipAccountBean;
import com.chinacreator.video.mapper.ComplementSendDao;
import com.chinacreator.video.service.ComplementSendService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.service.VipControlService;
import com.chinacreator.video.util.VipChangeUtil;

@Component
public class GetVipService {

    @Autowired
    VipControlService vipControlService;

    @Autowired
    VipChangeUtil vipChangeUtil;

    @Autowired
    ComplementSendDao complementSendDao;

    @Autowired
    ComplementSendService complementSendService;

    public void give(VipInfo activityInfo, String vipid, String vippwd) throws BussinessException {
        vipControlService.canGiveVip(activityInfo);
        try {
            String remark = null;
            if ("tencent".equals(activityInfo.getCpid())) {
                if ("4".equals(activityInfo.getUsertype())) {
                    remark = "会员产品";
                } else {
                    remark = activityInfo.getUserid();
                }
            }
            //20220909 添加 由于keep领取时，调下游接口必须要传递userid参数，故此处需要判断
            if ("keep".equals(activityInfo.getCpid())) {
                remark = activityInfo.getUserid();
            }

            String orderid = new SimpleDateFormat("yyyyMM").format(new Date()) + "01" + activityInfo.getUserid() + "_" + activityInfo.getActivetype() + "_" + activityInfo.getSpid();

            vipChangeUtil.getVip(vipid, activityInfo.getUserid(), activityInfo.getActivetype(), vippwd, activityInfo.getUsertype(), activityInfo.getUserval(), orderid, remark, activityInfo.getType() + "");

            // 更新账期数据
            complementSendService.updateJoinAccount(activityInfo,"","",orderid);

            vipControlService.saveVipGive(activityInfo, "0");
        } catch (Exception e) {
            throw e;
        }
    }


    public void giveMulti(VipInfo activityInfo, String vipid, String vippwd) throws BussinessException {
        vipControlService.canGiveVip(activityInfo);
        try {
            String orderid = new SimpleDateFormat("yyyyMM").format(new Date()) + "01" + activityInfo.getUserid() + "_" + activityInfo.getActivetype();

            if (!vipControlService.vipMultiCanGive(activityInfo.getActivetype(), activityInfo.getUserid(), orderid, activityInfo.getGivecount())) {
                throw new BussinessException("8004", "重复领取会员请求，请稍后再试");
            }

            String remark = null;
            if ("tencent".equals(activityInfo.getCpid())) {
                if ("4".equals(activityInfo.getUsertype())) {
                    remark = "会员产品";
                } else {
                    remark = activityInfo.getUserid();
                }
            }

            vipChangeUtil.getVip(vipid, activityInfo.getUserid(), activityInfo.getActivetype(), vippwd, activityInfo.getUsertype(), activityInfo.getUserval(), orderid, remark, activityInfo.getType() + "");

            // 更新账期表的数据
            complementSendService.updateJoinAccount(activityInfo, "", "", orderid);
            vipControlService.saveVipGive(activityInfo, "0");
        } catch (Exception e) {
            throw e;
        }
    }


    public void giveMangoFree(VipInfo activityInfo, String vipid, String vippwd) throws BussinessException {
        vipControlService.canGiveVip(activityInfo);
        try {
            String remark = null;
            String orderid = new SimpleDateFormat("yyyy").format(new Date()) + "0X01" + activityInfo.getUserid() + "_" + activityInfo.getActivetype() + "_" + activityInfo.getSpid();

            vipChangeUtil.getVip(vipid, activityInfo.getUserid(), activityInfo.getActivetype(), vippwd, activityInfo.getUsertype(), activityInfo.getUserval(), orderid, remark, activityInfo.getType() + "");

            complementSendService.updateJoinAccount(activityInfo,"","",orderid);
            vipControlService.saveVipGive(activityInfo, "0");
        } catch (Exception e) {
            throw e;
        }
    }


    //会员领取新增异步流程20220921
    public void giveAsyn(VipInfo activityInfo, String vipid, String vippwd, ActivityBean activityBean) throws BussinessException {
        vipControlService.canGiveVip(activityInfo);
        try {
            String remark = null;
            if ("tencent".equals(activityInfo.getCpid())) {
                if ("4".equals(activityInfo.getUsertype())) {
                    remark = "会员产品";
                } else {
                    remark = activityInfo.getUserid();
                }
            }
            //20220909 添加 由于keep领取时，调下游接口必须要传递userid参数，故此处需要判断
            if ("keep".equals(activityInfo.getCpid())) {
                remark = activityInfo.getUserid();
            }

            String orderid = new SimpleDateFormat("yyyyMM").format(new Date()) + "01" + activityInfo.getUserid() + "_" + activityInfo.getActivetype() + "_" + activityInfo.getSpid();

            vipChangeUtil.getVipAsyn(vipid, activityInfo.getUserid(), activityInfo.getActivetype(), vippwd, activityInfo.getUsertype(), activityInfo.getUserval(), orderid, remark, activityInfo.getType() + "", activityBean);

            complementSendService.updateJoinAccount(activityInfo,"","",orderid);
            vipControlService.saveVipGive(activityInfo, "0");
        } catch (Exception e) {
            throw e;
        }
    }

}
