package com.chinacreator.video.thread;

import java.util.List;

import com.alibaba.fastjson.JSON;
import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.ActivityVipConfigBean;
import com.chinacreator.video.bean.ActivityVipLogBean;
import com.chinacreator.video.bean.UserMsgBean;
import com.chinacreator.video.bean.VipInfo;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.service.ActivityVipConfigService;
import com.chinacreator.video.service.AiqiyiGiveMonthVipService;
import com.chinacreator.video.service.GiveVipService;
import com.chinacreator.video.service.VipMultiService;
import com.chinacreator.video.service.YoukuVipService;

public class VipMultiThread extends Thread{
	private VipInfo vipinfo;
	
	private List<ActivityBean> vipList ;
	
	private List<ActivityBean> cancelVipList ;
	
	private VipMultiService service;
	
	private ActivityVipConfigService vipConfigService;

    public VipMultiThread(VipInfo vipinfo,List<ActivityBean> vipList,VipMultiService service,ActivityVipConfigService vipConfigService,List<ActivityBean> cancelVipList)
    {
    	this.vipinfo = vipinfo;
        this.vipList = vipList;
        this.cancelVipList = cancelVipList;
        this.service = service;
        this.vipConfigService = vipConfigService;
    }
	
    public void run(){
    	
    	boolean flag = false;
        if(vipList != null && vipList.size()>0){
        	flag = true;
        	for(ActivityBean bean :vipList){
        		try {
        			vipinfo.setCpid(bean.getCpid());
        			vipinfo.setSpid(bean.getSpid());
        			vipinfo.setUsertype("4");
        			vipinfo.setUserval(bean.getUserid());
        			
        			ActivityVipConfigBean config = vipConfigService.getVipConfigBean(vipinfo.getActivetype(), bean.getCpid(), bean.getSpid());
        			if(config != null){
        				vipinfo.setVippool(config.getVippool());
        			}
        			
        			String vipname="";
        			if("tencent".equals(bean.getCpid())) {
        				GiveVipService giveVipService = service.getTencentService();
        				giveVipService.give(vipinfo);
        				
        				vipname="腾讯视频月会员";
        			}else if("aiqy".equals(bean.getCpid())) {
        				
        				AiqiyiGiveMonthVipService aiqyMonthService = service.getAiqyMonthService();
        				aiqyMonthService.give(vipinfo);
        				
        				vipname="爱奇艺视频月会员";
        			}else if ("youtu".equals(bean.getCpid())){
        				
        				YoukuVipService youkuService = service.getYoukuService();
        				youkuService.giveVip(vipinfo);
        				
        				vipname="优酷视频月会员";
        			} else {
        				throw new BussinessException("9088", "该cp暂未开放");
        			}
					
        			try {
        				//会员赠送成功
        				bean.setVipstatus("0");
        				bean.setVipconflag("0");
        				service.getActiveDao().updateVipMulti(bean);
        				service.getUserMsgDao().insertMsg(getUserMsgBean(vipinfo));
        				
        				ActivityVipLogBean  log = new ActivityVipLogBean();
        				log.setUserid(bean.getUserid());
        				log.setActivetype(bean.getActiveType());
        				log.setCpid(bean.getFhcpid());
        				log.setSpid(bean.getFhspid());
        				log.setGivecpid(bean.getCpid());
        				log.setLogtype("会员领取");
        				log.setRemark("成功领取"+vipname);
        				service.getActiveVipLogDao().insertLog(log);
					} catch (Exception e) {
						e.printStackTrace();
					}
				} catch (Exception e) {
					e.printStackTrace();
					
					//领取成功
					flag = false;
					
					//领取失败重新领取
					bean.setVipstatus("2");
        			service.getActiveDao().updateVip(bean);
				}
        	}
        	
        	
        	//领取成功后，把原有的失效
        	if(flag){
        		if(cancelVipList != null && cancelVipList.size()>0){
        			for(ActivityBean bean :cancelVipList){
        				try {
        					bean.setVipstatus("4");
            				bean.setVipconflag("1");
            				service.getActiveDao().updateVipMulti(bean);
						} catch (Exception e) {}
        			}
        		}
        	}
        }
    }
    
    
	public UserMsgBean getUserMsgBean(VipInfo activityInfo) {
		UserMsgBean userMsgBean = new UserMsgBean();
		userMsgBean.setActiveid(activityInfo.getActivetype());
		userMsgBean.setUserid(activityInfo.getUserid());
		userMsgBean.setCpid(activityInfo.getCpid());
		userMsgBean.setSpid(activityInfo.getSpid());
		userMsgBean.setMsg1(activityInfo.getUserval());
		userMsgBean.setMsg2(activityInfo.getUsertype());
		userMsgBean.setMsg3(activityInfo.getVipname() == null ?"":activityInfo.getVipname());
		System.out.println("UserMsgBean="+JSON.toJSONString(activityInfo));
		return userMsgBean;
	}
	

}
