package com.chinacreator.video.util;

import java.util.HashMap;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSON;
import com.chinacreator.video.mapper.DictionaryDao;

/**
 * <p>Description: 调用vac工具类</p>
 * <p>Copyright: Copyright (c) 2013</p>
 * <p>Company: Chinacreator（长沙科创集成）</p>
 * <p>creationTime: 2013-4-12</p>
 * @author  
 * @version 1.0
 */
public class VacUtil {
	
	
	private static final  Logger log = LoggerFactory.getLogger("vaclog");


	/**
	 * 原有VAC接口，无sequence则不传
	 * @param userId
	 * @param spCode
	 * @param productId
	 * @param type
	 * @return
	 * @throws Exception
	 */
	public static String vac(String userId,String spCode, String productId,String type) throws Exception{
		return vac(userId,spCode,productId,type,null);
	}

	/**
	 * 调用vac接口，vac接口调用地址，由字典表配置
	 * @param userId 手机号码
	 * @param spCode sp编码
	 * @param productId 产品标识
	 * @param type 1表示包月订购，2表示退订，0：单次订购
	 * @param sequence  同步统一认证所需的序列号
	 * @return
	 */
	public static String vac(String userId,String spCode, String productId,String type, String sequence) throws Exception{
		Map<String,String> logMap = new HashMap<>();
		logMap.put("userid", userId);
		logMap.put("productId", productId);
		logMap.put("type", type);
		logMap.put("sequence", sequence);
		long startTime = System.currentTimeMillis();
		DictionaryDao dictionaryDao = SpringUtils.getBean(DictionaryDao.class);
		String vacUrl = dictionaryDao.getValue("vacUrl");
		if(vacUrl.indexOf("?") == -1) {
			vacUrl += "?";
		} else {
			vacUrl += "&";
		}
		vacUrl += "usermob=" + userId;
		vacUrl += "&productid=" + productId;
		vacUrl += "&vacid=" + productId;
		vacUrl += "&spcode=" + spCode;
		vacUrl += "&ordertype=" + type;
		vacUrl += "&servicetype=80";
		vacUrl += "&sequence=" + sequence;
		String result = URLUtil.get(vacUrl);
		logMap.put("result", result);
		logMap.put("times", String.valueOf(System.currentTimeMillis()-startTime));
		log.info(JSON.toJSONString(logMap));
		return  result;
	}
}
