package com.chinacreator.video.util;

import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.chinacreator.video.bean.ActivityBean;
import com.chinacreator.video.bean.VipAccountBean;
import com.chinacreator.video.exception.BussinessException;
import com.chinacreator.video.mapper.ActiveDao;
import com.chinacreator.video.mapper.ComplementSendDao;
import com.chinacreator.video.mapper.DictionaryDao;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class VipChangeUtil {
    private static Logger ErrorLOGGER = LoggerFactory.getLogger("ERROR");
    @Autowired
    private DictionaryDao dictionaryDao;
    @Autowired
    private ActiveDao activeDao;

    @Autowired
    private ComplementSendDao complementSendDao;

    public void getVip(String vipid, String userid, String channel, String pwd, String usertype, String userval, String orderid, String remark, String type) throws BussinessException {
        try {
            Map<String, String> param = new HashMap<>();
            String apptype = "2";
            String viptype = "2";
            String vipval = "1";
            String timeStamp = System.currentTimeMillis() / 1000L + "";
            String signature = MD5.MD5Encode(orderid + channel + vipid + userval + pwd + timeStamp);

            param.put("apptype", apptype);
            param.put("orderid", orderid);
            param.put("vipid", vipid);
            param.put("channel", channel);
            param.put("usertype", usertype);
            param.put("userval", userval);
            param.put("vipval", vipval);
            param.put("viptype", viptype);
            param.put("signature", signature);
            param.put("timestamp", timeStamp);
            if (userid != null && !"".equals(userid)) {
                param.put("userid", userid);
            }
            if (type != null && !"".equals(type)) {
                param.put("type", type);
            }
            if (remark != null && !"".equals(remark)) {
                param.put("remark", URLEncoder.encode(remark, "utf-8"));
            }
            String baseurl = dictionaryDao.getValue("videovipUrl");
            String result = URLUtil.get(URLUtil.mapToUrl(baseurl, param));
            ErrorLOGGER.info("用户续送会员池的信息：" + param.toString());
            JSONObject obj = JSON.parseObject(result);
            String resultcode = obj.getString("resultcode");
            String errorinfo = obj.getString("errorinfo");
            if (!"0".equals(resultcode) && !("10002".equals(resultcode) && "orderid不能重复使用".equals(errorinfo))
                    && !("-1".equals(resultcode) && "提交成功，正在处理中".equals(errorinfo))) {
                throw new BussinessException(resultcode, errorinfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            if (e instanceof BussinessException)
                throw (BussinessException) e;
            else
                throw new BussinessException("8000", e.getMessage());
        }
    }

    //会员领取新增异步流程20220921
    public void getVipAsyn(String vipid, String userid, String channel, String pwd, String usertype, String userval, String orderid, String remark, String type, ActivityBean activityBean) throws BussinessException {

        try {
            Map<String, String> param = new HashMap<>();
            String apptype = "2";
            String viptype = "2";
            String vipval = "1";
            String timeStamp = System.currentTimeMillis() / 1000L + "";
            String signature = MD5.MD5Encode(orderid + channel + vipid + userval + pwd + timeStamp);

            param.put("apptype", apptype);
            param.put("orderid", orderid);
            param.put("vipid", vipid);
            param.put("channel", channel);
            param.put("usertype", usertype);
            param.put("userval", userval);
            param.put("vipval", vipval);
            param.put("viptype", viptype);
            param.put("signature", signature);
            param.put("timestamp", timeStamp);
            if (userid != null && !"".equals(userid)) {
                param.put("userid", userid);
            }
            if (type != null && !"".equals(type)) {
                param.put("type", type);
            }
            if (remark != null && !"".equals(remark)) {
                param.put("remark", URLEncoder.encode(remark, "utf-8"));
            }
            String baseurl = dictionaryDao.getValue("videovipUrl");
            String result = URLUtil.get(URLUtil.mapToUrl(baseurl, param));
            JSONObject obj = JSON.parseObject(result);
            String resultcode = obj.getString("resultcode");
            String errorinfo = obj.getString("errorinfo");
            //20220921 加入异步流程
            String status = "990099";
            if ("-1".equals(resultcode) && "提交成功，正在处理中".equals(errorinfo)) {  //是异步流程
                if (StringUtils.isEmpty(type) || !"1".equals(type)) { //领取，续送在前面处理的
                    activityBean.setVipstatus(status);
                    activityBean.setRequestid(orderid);   // tl_order_log的requestid
                    activeDao.updateVipWithRequestid(activityBean);
                }
                VipAccountBean vipAccount = new VipAccountBean();
                vipAccount.setRequestid(orderid);
                vipAccount.setVipstatus("3");
                vipAccount.setUserid(activityBean.getUserid());
                vipAccount.setSpid(activityBean.getSpid());
                vipAccount.setActivitytype(activityBean.getActiveType());
                if (StringUtils.isEmpty(type) || !"1".equals(type)){
                    vipAccount.setViptype("2");   // 手动领取
                }else {
                    vipAccount.setViptype("1");   // 自动续送
                }
                vipAccount.setViptime(new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()));
                complementSendDao.updateRequestid(vipAccount);   // 对于异步数据先更新状态
                throw new BussinessException(status, errorinfo);
            } else {
                if (!"0".equals(resultcode) && !("10002".equals(resultcode) && "orderid不能重复使用".equals(errorinfo))) {
                    throw new BussinessException(resultcode, errorinfo);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            if (e instanceof BussinessException)
                throw (BussinessException) e;
            else
                throw new BussinessException("8000", e.getMessage());
        }
    }


    /**
     * 补送
     *
     * @param vipAccount
     * @param orderid
     * @param remark
     */
    public void regetVip(VipAccountBean vipAccount, String orderid, String remark) throws Exception {
        try {
            Map<String, String> param = new HashMap<>();
            String apptype = "2";
            String viptype = "2";
            String vipval = "1";
            String timeStamp = System.currentTimeMillis() / 1000L + "";
            String channel = "jqptbsqdacoount";   // 鉴权平台账期补送渠道
            String signature = MD5.MD5Encode(orderid + channel + vipAccount.getRevipid() + vipAccount.getUserid() + vipAccount.getVippwd() + timeStamp);
            param.put("apptype", apptype);
            param.put("orderid", orderid);
            param.put("vipid", vipAccount.getRevipid());
            param.put("channel", channel);
            param.put("usertype", "4");
            param.put("userval", vipAccount.getUserid());
            param.put("vipval", vipval);
            param.put("viptype", viptype);
            param.put("signature", signature);
            param.put("timestamp", timeStamp);
            param.put("userid", vipAccount.getUserid());
            if (remark != null && !"".equals(remark)) {
                param.put("remark", URLEncoder.encode(remark, "utf-8"));
            }
            String baseurl = dictionaryDao.getValue("videovipUrl");
            String result = URLUtil.get(URLUtil.mapToUrl(baseurl, param));
            JSONObject obj = JSON.parseObject(result);
            String resultcode = obj.getString("resultcode");
            String errorinfo = obj.getString("errorinfo");
            vipAccount.setRequestid(orderid);   // tl_order_log的requestid
            if ("0".equals(resultcode)) {
                vipAccount.setVipstatus(resultcode);
            } else if ("-1".equals(resultcode) && "提交成功，正在处理中".equals(errorinfo)) {  //是异步流程
                vipAccount.setVipstatus("3");
                vipAccount.setViptype("3");
                activeDao.updateAccount(vipAccount);
                throw new BussinessException("9999", "会员补送中，请稍后查看");
            } else {
                throw new BussinessException(resultcode, errorinfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
    }
}
